local addonName, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local match = _G.string.match
local find = _G.string.find
--
local Create = addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGButton=Create.PIGButton
local PIGFontString=Create.PIGFontString
local BackdropColor=Create.BackdropColor
local PIGLine=Create.PIGLine
local PIGEnter=Create.PIGEnter
---
local InvSlot=addonTable.Data.InvSlot
local EnchantItemID=addonTable.Data.EnchantItemID
local EnchantSpellID=addonTable.Data.EnchantSpellID
local EnchantSlot=addonTable.Data.EnchantSlot
local EnchantSlotID=addonTable.Data.EnchantSlotID
-------------
local ListWWWHHH = {200,419,18,36,16}--3Gembut/4buweiW

--获取物品属性列表
local Plisttip = CreateFrame("GameTooltip", "Plisttip_UI", UIParent, "GameTooltipTemplate")
local function PIGGetItemStats(unit,Slot,stats)
	if unit=="yc" then
		Plisttip:SetHyperlink(Slot)
	else
		--local link = GetInventoryItemLink(unit,Slot) or select(2, Plisttip:GetItem())
		Plisttip:SetOwner(UIParent, "ANCHOR_NONE")
	    Plisttip:SetInventoryItem(unit, Slot)
	end
    local hangname = Plisttip:GetName()
    local txtNum = Plisttip:NumLines()
    if txtNum then
    	local quality=1
    	if unit=="yc" then
			quality = C_Item.GetItemQualityByID(Slot)
    	else
	    	quality = GetInventoryItemQuality(unit, Slot)
	    end
    	for g = 2, txtNum do
	    	local text = _G[hangname.."TextLeft" .. g]:GetText() or ""
	    	--local r, g, b = _G[hangname.."TextLeft" .. g]:GetTextColor()
	    	tinsert(stats, {text,quality})
	    end
	end
end
--获取宝石槽位信息
local function PIGGetGemList(Link)
	local baoshiinfo = {}
    local statsg = GetItemStats(Link)
    for key, num in pairs(statsg) do
        if (key:match("EMPTY_SOCKET_")) then
            for i = 1, num do
                table.insert(baoshiinfo, _G[key])
            end
        end
    end
    return baoshiinfo
end
local function add_GemBut(self,id)
	local fujiname=self:GetName()
	local Gembut = CreateFrame("Frame", fujiname.."_"..id, self,"BackdropTemplate");
	Gembut:SetBackdrop({edgeFile = "Interface/AddOns/"..addonName.."/Libs/Pig_Border.blp", edgeSize = 10});
	Gembut:SetBackdropBorderColor(0, 0, 0, 1);
	Gembut:SetSize(ListWWWHHH[3],ListWWWHHH[3]);
	if id==1 then
		Gembut:SetPoint("LEFT",self.itemlink,"RIGHT",0,-1);
	else
		Gembut:SetPoint("LEFT",_G[fujiname.."_"..(id-1)],"RIGHT",1,0);
	end
	Gembut.icon = Gembut:CreateTexture();
	Gembut.icon:SetPoint("TOPLEFT",Gembut,"TOPLEFT",2,-2);
	Gembut.icon:SetPoint("BOTTOMRIGHT",Gembut,"BOTTOMRIGHT",-2,2);
	Gembut:SetScript("OnLeave", function ()
		GameTooltip:ClearLines();
		GameTooltip:Hide() 
	end);
	return Gembut
end
local function ShowGemBut(Gemse,GemitemLink,nulltishi)
	if GemitemLink then
		Gemse.icon:SetDesaturated(false)
       	local _, _, quality, _, _, _, _, _, _, texture = GetItemInfo(GemitemLink)
       	local r, g, b = GetItemQualityColor(quality or 0)
       	Gemse.icon:SetTexture(texture)
    	Gemse:SetBackdropBorderColor(r, g, b, 1);
    else
    	Gemse.icon:SetDesaturated(true)
    	Gemse:SetBackdropBorderColor(0.5, 0.5, 0.5, 1);
    	if nulltishi==55655 then
    		local name, rank, texture = GetSpellInfo(55655)
    		Gemse.icon:SetTexture(texture)
	    else
	    	Gemse.icon:SetTexture(134071)
	    end
  	end
    Gemse:SetScript("OnEnter", function (self)
		GameTooltip:ClearLines();
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
		if GemitemLink then
			GameTooltip:SetHyperlink(GemitemLink)
		else
			if nulltishi==55655 then
				GameTooltip:SetSpellByID(55655)
				GameTooltip:AddLine("|cff00FFFF!Pig:|r|cffFF0000"..WAISTSLOT.."未打孔|r")
			else
				GameTooltip:AddLine(nulltishi)
			end
		end
		GameTooltip:Show();
	end);
	Gemse:SetScript("OnLeave", function ()
		GameTooltip:ClearLines();
		GameTooltip:Hide() 
	end);
end
local function GetGemInfo(Gemse,id,nulltishi,duixiang,Slot,itemLink)
	if duixiang=="yc" then
		local _, GemitemLink = GetItemGem(itemLink, id)
		if GemitemLink then
			ShowGemBut(Gemse,GemitemLink)
		else
			Gemse.getnum=Gemse.getnum+1
			if Gemse:GetParent():GetParent():GetParent():IsShown() then
				if Gemse.getnum<5 then
					if Gemse.ItemGem then Gemse.ItemGem:Cancel() end
					Gemse.ItemGem=C_Timer.NewTimer(0.2,function()
						GetGemInfo(Gemse,id,nulltishi,duixiang,Slot,itemLink)
					end)
				else
					ShowGemBut(Gemse,GemitemLink,nulltishi)
				end
			end
		end
	else	
		local itemLink=GetInventoryItemLink(duixiang, Slot)
		if itemLink then
			local _, GemitemLink = GetItemGem(itemLink, id)
			if GemitemLink then
				ShowGemBut(Gemse,GemitemLink)
		    else
		    	Gemse.getnum=Gemse.getnum+1
				if Gemse:GetParent():GetParent():GetParent():IsShown() then
					if Gemse.getnum<5 then
						if Gemse.ItemGem then Gemse.ItemGem:Cancel() end
						Gemse.ItemGem=C_Timer.NewTimer(0.2,function()
							GetGemInfo(Gemse,id,nulltishi,duixiang,Slot,itemLink)
						end)
					else
						ShowGemBut(Gemse,GemitemLink,nulltishi)
					end
				end
		  	end
		-- else
		-- 	Gemse.getnum=Gemse.getnum+1
		-- 	if Gemse:GetParent():GetParent():GetParent():IsShown() then
		-- 		if Gemse.getnum<5 then
		-- 			if Gemse.ItemGem then Gemse.ItemGem:Cancel() end
		-- 			Gemse.ItemGem=C_Timer.NewTimer(0.2,function()
		-- 				GetGemInfo(Gemse,id,nulltishi,duixiang,Slot,itemLink)
		-- 			end)
		-- 		else
		-- 			ShowGemBut(Gemse,GemitemLink,nulltishi)
		-- 		end
		-- 	end
		end
	end
end
--显示附魔物品信息
local function PIGGetEnchantID(itemLink)
	local fumoid = itemLink:match("|?c?f?f?%x*|?Hitem:?%d+:?(%d*):?")
	if fumoid and fumoid~="" and fumoid~=" " then
		return tonumber(fumoid)
	end
	return 0
end
local function ShowEnchantInfo(EnchantBut,ItemID)
	local _, ItemLink, quality, _, _, _, _, _, _, texture = GetItemInfo(ItemID)
	if ItemLink then
		EnchantBut.icon:SetTexture(texture)
		local r, g, b = GetItemQualityColor(quality or 0)
		EnchantBut:SetBackdropBorderColor(r, g, b, 1);
		EnchantBut:SetScript("OnEnter", function (self)
			GameTooltip:ClearLines();
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
			if ItemLink then
				GameTooltip:SetHyperlink(ItemLink)
			else
				GameTooltip:AddLine("|cff00FFFF!Pig:|r"..ENCHANTS..INFO..UNKNOWN)
			end
			GameTooltip:Show();
		end);
		EnchantBut:SetScript("OnLeave", function ()
			GameTooltip:ClearLines();
			GameTooltip:Hide() 
		end);
	else
		EnchantBut.getnum=EnchantBut.getnum+1
		if EnchantBut:GetParent():GetParent():GetParent():IsShown() then
			if EnchantBut.getnum<5 then
				if EnchantBut.EnchantInfo then EnchantBut.EnchantInfo:Cancel() end
				EnchantBut.EnchantInfo=C_Timer.NewTimer(0.2,function()
					ShowEnchantInfo(EnchantBut,ItemID)
				end)
			end
		end
	end
end
---add
local function CZ_ItemListinfo(fujikk,Slot,fujiname)
	fujikk:SetBackdropBorderColor(0.5, 0.5, 0.5,0.5)--部位边框
	fujikk.t:SetTextColor(0.5, 0.5, 0.5,0.8);--部位名
	fujikk.itemlink.cunzai=nil
	fujikk.itemlink:SetWidth(0.1);--link宽
	fujikk.itemlink.lv:SetText(" ")--物品等级
	fujikk.itemlink.t:SetText(" ")--物品link
	for Gemid=1,5 do
		local Gemui = _G[fujiname.."_"..Slot.."_"..Gemid]
		Gemui:SetWidth(0.01)
		Gemui:SetAlpha(0)
		Gemui:SetBackdropBorderColor(0, 0, 0, 1);
	end
	fujikk.itemlink:SetScript("OnEnter",nil);
	fujikk.itemlink:SetScript("OnDoubleClick",nil)
end
local function CZ_taozhuanginfo(self,fujiname)
	for tid=1,4 do
		local taoui = _G[fujiname.."_".."tao_"..tid]
		taoui:SetTextColor(0.5, 0.5, 0.5, 1);
		if tid==1 then
			taoui:SetText(string.format(BOSS_BANNER_LOOT_SET,NONE))
		else
			taoui:SetText("")
		end
	end
	self:SetHeight(ListWWWHHH[2])
end
---套装
local function GettaozhuangInfo(dainfo,taoname,dangqian,zongshu,quality)
	local cunzaitaoz = true
	for ivv=1,#dainfo do
		if taoname==dainfo[ivv][1] then
			cunzaitaoz = false
			dainfo[ivv][2]=dainfo[ivv][2]+1
			dainfo[ivv][3]=zongshu
			break
		end
	end
	if cunzaitaoz then
		table.insert(dainfo,{taoname,1,zongshu,quality})
	end
	return dainfo
end
local function PIGGetTaozhuang(statsg)
	local taozhuainfo = {}
	for iv=1,#statsg do
		local kaishi,jieshu,taoname,dangqian,zongshu = statsg[iv][1]:find("(.+)（(%d)/(%d)）")
		if taoname and dangqian and zongshu then
			if zongshu=="0" then
				taozhuainfo = {}
				return false
			else
				taozhuainfo = GettaozhuangInfo(taozhuainfo,taoname,dangqian,zongshu,statsg[iv][2])
			end
		else
			local kaishi,jieshu,taoname,dangqian,zongshu = statsg[iv][1]:find("(.+)(%(%d/%d%))")
			if taoname and dangqian and zongshu then
				if zongshu=="0" then
					taozhuainfo = {}
					return false
				else
					taozhuainfo = GettaozhuangInfo(taozhuainfo,taoname,dangqian,zongshu,statsg[iv][2])
				end
			end
		end
	end
	return taozhuainfo
end
--显示信息
local function ShowItemList(Parent,unit,Data,taozhuang)
	local Parentname = Parent:GetName()
	Parent.zhuangbeiInfo = {
		["allleve"]=0,["wuqixiuzhengV"]="",["slots"]=ListWWWHHH[5],
		["ALLWWWW"]=ListWWWHHH[1],["hangWWWW"]=0,["fumoNum"]=0,
	}
	for i = 1, #InvSlot["ID"] do
		local fujikk = _G[Parentname.."_"..InvSlot["ID"][i]]
		-----
		local itemLink=Data[InvSlot["ID"][i]]
		if itemLink then
			fujikk.t:SetTextColor(0, 1, 1, 0.8);
			fujikk:SetBackdropBorderColor(0, 1, 1, 0.5)
			local effectiveILvl, isPreview, baseILvl = GetDetailedItemLevelInfo(itemLink)
			if InvSlot["ID"][i]~=16 and InvSlot["ID"][i]~=17 and InvSlot["ID"][i]~=18 then
				Parent.zhuangbeiInfo.allleve=Parent.zhuangbeiInfo.allleve+effectiveILvl
			end
			fujikk.itemlink.lv:SetText(effectiveILvl)
			fujikk.itemlink.lv:SetTextColor(1, 1, 1, 1);
			fujikk.itemlink.t:SetText(itemLink)
			---	
			fujikk.itemlink:SetScript("OnEnter", function (self)
				GameTooltip:ClearLines();
				GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
				if unit=="yc" then
					GameTooltip:SetHyperlink(itemLink)
				else
					GameTooltip:SetInventoryItem(unit, InvSlot["ID"][i])
				end
				fujikk:SetBackdropColor(0, 1, 1, 0.5)
				fujikk.t:SetTextColor(1, 1, 0.8, 1);
				GameTooltip:Show();
			end);
			fujikk.itemlink:SetScript("OnDoubleClick", function(self)
                ChatEdit_ActivateChat(ChatEdit_ChooseBoxForSend())
                ChatEdit_InsertLink(itemLink)
            end)
        	---
		    local baoshiinfo=PIGGetGemList(itemLink)
		    if tocversion>29999 and tocversion<50000 and InvSlot["ID"][i]==6 then
		   		table.insert(baoshiinfo,55655)
		   	end
		    local baoshiNUM=#baoshiinfo
			for Gemi=1,baoshiNUM do
				local Gemui = _G[Parentname.."_"..InvSlot["ID"][i].."_"..Gemi]
				Gemui:SetWidth(ListWWWHHH[3])
				Gemui:SetAlpha(1)
				Gemui.getnum=0
				GetGemInfo(Gemui,Gemi,baoshiinfo[Gemi],unit,InvSlot["ID"][i],itemLink)
			end
			---
			local fumoid = PIGGetEnchantID(itemLink)
			local Enchantui=_G[Parentname.."_"..InvSlot["ID"][i].."_"..5]
			if fumoid>0 then
				Parent.zhuangbeiInfo.fumoNum=1
				Enchantui:SetWidth(ListWWWHHH[3])
				Enchantui:SetAlpha(1)
				Enchantui.icon:SetDesaturated(false)
				if EnchantItemID[fumoid] then
					PIGGetItemInfo(EnchantItemID[fumoid])--获取未缓存物品信息
					Enchantui.getnum=0
					ShowEnchantInfo(Enchantui,EnchantItemID[fumoid])
				elseif EnchantSpellID[fumoid] then
					local name, rank, texture = GetSpellInfo(EnchantSpellID[fumoid])
					Enchantui.icon:SetTexture(texture)
					Enchantui:SetBackdropBorderColor(1, 0.843, 0, 0.8);
					Enchantui:SetScript("OnEnter", function (self)
						GameTooltip:ClearLines();
						GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
						GameTooltip:SetSpellByID(EnchantSpellID[fumoid])
						GameTooltip:Show();
					end);
				elseif EnchantSlotID[fumoid] then
					local itemID, itemType, itemSubType, itemEquipLoc = GetItemInfoInstant(itemLink)
					local EnchantSpell = EnchantSlotID[fumoid][itemEquipLoc]
					local name, rank, texture = GetSpellInfo(EnchantSpell)
					Enchantui.icon:SetTexture(texture)
					Enchantui:SetBackdropBorderColor(1, 0.843, 0, 0.8);
					Enchantui:SetScript("OnEnter", function (self)
						GameTooltip:ClearLines();
						GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
						GameTooltip:SetSpellByID(EnchantSpell)
						GameTooltip:Show();
					end);
				else
					Enchantui.icon:SetTexture(136244)
					Enchantui:SetScript("OnEnter", function (self)
						GameTooltip:ClearLines();
						GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
						GameTooltip:AddLine(ENCHANTS.."ID:"..fumoid)
						GameTooltip:AddLine(UNKNOWN..ENCHANTS..INFO)
						GameTooltip:Show();
					end);
				end
			else
				if EnchantSlot[InvSlot["ID"][i]] then
					Parent.zhuangbeiInfo.fumoNum=1
					local itemID, itemType, itemSubType, itemEquipLoc = GetItemInfoInstant(itemLink)
					if InvSlot["ID"][i]==17 and itemEquipLoc=="INVTYPE_HOLDABLE" then 
					else
						Enchantui:SetWidth(ListWWWHHH[3])
						Enchantui:SetAlpha(1)
						Enchantui.icon:SetDesaturated(true)
						Enchantui:SetBackdropBorderColor(0.5, 0.5, 0.5, 1);
						Enchantui.icon:SetTexture(136244)
						Enchantui:SetScript("OnEnter", function (self)
							GameTooltip:ClearLines();
							GameTooltip:SetOwner(self, "ANCHOR_RIGHT",0,0);
							GameTooltip:AddLine("|cff00FFFF!Pig:|r|cffFF0000"..InvSlot["Name"][InvSlot["ID"][i]][2]..NONE..ENCHANTS.."|r")
							GameTooltip:Show();
						end);
					end
				end
			end
			---
			local width = fujikk.itemlink.t:GetStringWidth()+fujikk.itemlink.lv:GetStringWidth()
			fujikk.itemlink:SetWidth(width);
			Parent.zhuangbeiInfo.hangWWWW = width+baoshiNUM*(ListWWWHHH[3]+1)+ListWWWHHH[4]+10
			if Parent.zhuangbeiInfo.fumoNum>0 then
				Parent.zhuangbeiInfo.hangWWWW=Parent.zhuangbeiInfo.hangWWWW+ListWWWHHH[3]+2
			end
			if Parent.zhuangbeiInfo.hangWWWW>Parent.zhuangbeiInfo.ALLWWWW then
				Parent.zhuangbeiInfo.ALLWWWW = Parent.zhuangbeiInfo.hangWWWW
			end
		end
	end
	--装等
	if GetAverageItemLevel and unit=="player" then
		local avgItemLevel, avgItemLevelEquipped, avgItemLevelPvP = GetAverageItemLevel();
		Parent.pingjunLV_V:SetText(string.format("%.2f",avgItemLevelEquipped))
	else
		local wuqiLV={{0,"null"},{0,"null"},{0,"null"}}
		if Data[16] then
			wuqiLV[1][1] = GetDetailedItemLevelInfo(Data[16])
			local itemID, itemType, itemSubType, itemEquipLoc = GetItemInfoInstant(Data[16])
			wuqiLV[1][2]=itemEquipLoc
		end
		if Data[17] then
			wuqiLV[2][1] = GetDetailedItemLevelInfo(Data[17])
			local itemID, itemType, itemSubType, itemEquipLoc = GetItemInfoInstant(Data[17])
			wuqiLV[2][2]=itemEquipLoc
		end
		--INVTYPE_2HWEAPON--双手
		--INVTYPE_WEAPONMAINHAND--主手
		--INVTYPE_SHIELD--副手
		--INVTYPE_WEAPON--单手
		if tocversion<50000 then
			if Data[18] then wuqiLV[3][1] = GetDetailedItemLevelInfo(Data[18]) end
			--新计算方式(主+副手/远程*2取其大者)
			if wuqiLV[1][1]>0 or wuqiLV[2][1]>0 or wuqiLV[3][1]>0 then
				if wuqiLV[1][2] == "INVTYPE_2HWEAPON" and wuqiLV[2][2] == "INVTYPE_2HWEAPON" then--泰坦之握双持双手
					local zuizhongwuqiLV = wuqiLV[1][1]+wuqiLV[2][1]
					Parent.zhuangbeiInfo.allleve = Parent.zhuangbeiInfo.allleve + zuizhongwuqiLV
				else
					if wuqiLV[1][2] == "INVTYPE_2HWEAPON" then--单双手武器
						local zuizhongwuqiLV = 0
						if Parent.jichuxinxi.zhiyeID==3 then
							local wuqizuidaV = max(wuqiLV[1][1],wuqiLV[3][1])
							zuizhongwuqiLV = wuqizuidaV*2
						else
							zuizhongwuqiLV = wuqiLV[1][1]*2
						end
						Parent.zhuangbeiInfo.allleve = Parent.zhuangbeiInfo.allleve + zuizhongwuqiLV
					else
						local zuizhongwuqiLV = 0
						if Parent.jichuxinxi.zhiyeID==3 then
							if wuqiLV[3][1]>wuqiLV[1][1] and wuqiLV[3][1]>wuqiLV[2][1] then
								zuizhongwuqiLV = wuqiLV[3][1]*2
							else
								zuizhongwuqiLV = wuqiLV[1][1]+wuqiLV[2][1]
							end
						else
							zuizhongwuqiLV = wuqiLV[1][1]+wuqiLV[2][1]
						end
						Parent.zhuangbeiInfo.allleve = Parent.zhuangbeiInfo.allleve + zuizhongwuqiLV
					end
				end
				if wuqiLV[1][2] == "INVTYPE_2HWEAPON" then--双手武器
					if wuqiLV[3][1]==0 then
						Parent.zhuangbeiInfo.wuqixiuzhengV=Parent.zhuangbeiInfo.wuqixiuzhengV.."-"
					end
				else
					if wuqiLV[1][1]==0 and wuqiLV[2][1]==0 then--缺主副手
						Parent.zhuangbeiInfo.wuqixiuzhengV=Parent.zhuangbeiInfo.wuqixiuzhengV.."--"
					elseif wuqiLV[1][1]==0 and wuqiLV[3][1]==0 then--缺主+远程
						Parent.zhuangbeiInfo.wuqixiuzhengV=Parent.zhuangbeiInfo.wuqixiuzhengV.."--"
					elseif wuqiLV[2][1]==0 and wuqiLV[3][1]==0 then--缺副+远程
						Parent.zhuangbeiInfo.wuqixiuzhengV=Parent.zhuangbeiInfo.wuqixiuzhengV.."--"
					elseif wuqiLV[1][1]==0 or wuqiLV[2][1]==0 or wuqiLV[3][1]==0 then--三槽缺1
						Parent.zhuangbeiInfo.wuqixiuzhengV=Parent.zhuangbeiInfo.wuqixiuzhengV.."-"
					end
				end
			end
		else
			if wuqiLV[1][2] == "INVTYPE_RANGED" or wuqiLV[1][2] == "INVTYPE_RANGEDRIGHT" or wuqiLV[1][2] == "INVTYPE_2HWEAPON" then--远程/双手武器
				Parent.zhuangbeiInfo.allleve = Parent.zhuangbeiInfo.allleve + wuqiLV[1][1]+wuqiLV[1][1]
			else
				Parent.zhuangbeiInfo.allleve = Parent.zhuangbeiInfo.allleve + wuqiLV[1][1]+wuqiLV[2][1]
			end
		end
		local pingjunLvl = Parent.zhuangbeiInfo.allleve/Parent.zhuangbeiInfo.slots
		Parent.pingjunLV_V:SetText(string.format("%.2f",pingjunLvl).."|cffFF0000"..Parent.zhuangbeiInfo.wuqixiuzhengV.."|r")
	end

	--调整UI宽度
	local biaotiwidth1 = Parent.pingjunLV:GetStringWidth()+Parent.pingjunLV_V:GetStringWidth()
	local biaotiwidth2 = Parent.talent_1:GetStringWidth()+Parent.talent_1v:GetStringWidth()
	local biaotiwidth = biaotiwidth1+biaotiwidth2+ListWWWHHH[3]+14
	if biaotiwidth>Parent.zhuangbeiInfo.ALLWWWW then
		Parent.zhuangbeiInfo.ALLWWWW=biaotiwidth
	end
	Parent:SetWidth(Parent.zhuangbeiInfo.ALLWWWW)
	--
	local taozhuangNum = #taozhuang
	for tid=1,taozhuangNum do
		local taoui = _G[Parentname.."_".."tao_"..tid]
		taoui:SetText(string.format(BOSS_BANNER_LOOT_SET,taozhuang[tid][1].."("..taozhuang[tid][2].."/"..taozhuang[tid][3]..")"))
		local r, g, b =GetItemQualityColor(taozhuang[tid][4] or 0)
		taoui:SetTextColor(r, g, b,1);
	end
	if taozhuangNum>1 then
		Parent:SetHeight(ListWWWHHH[2]+(taozhuangNum-1)*(ListWWWHHH[3]-3))
	end
	Parent:Show()
end
--获取装备信息
local function Getwupinmulu(Parent,unit)
	local ItemData={}
	local allstats={}
	if unit=="yc" then
		local zbinfo=yuanchengCFrame.Data_Info[2]
		for i = 1, #InvSlot["ID"] do
			if zbinfo[InvSlot["ID"][i]] then
				local itemName,itemLink,itemQuality,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,itemTexture= GetItemInfo(zbinfo[InvSlot["ID"][i]])
				ItemData[InvSlot["ID"][i]]=itemLink
				PIGGetItemStats(unit,itemLink,allstats)--保存装备属性信息
			end
		end
	else
		for i = 1, #InvSlot["ID"] do
			local itemLink=GetInventoryItemLink(unit, InvSlot["ID"][i])
			ItemData[InvSlot["ID"][i]]=itemLink
			PIGGetItemStats(unit,InvSlot["ID"][i],allstats)--保存装备属性信息
		end
	end
	local taozhuanginfo = PIGGetTaozhuang(allstats)
	if not taozhuanginfo then
		if not Parent:GetParent():IsShown() then return end
		Parent.taozhuanginfo=C_Timer.NewTimer(0.1,function()
			Getwupinmulu(Parent,unit)
		end)
		return
	end
	ShowItemList(Parent,unit,ItemData,taozhuanginfo)
end
------
local tishixx=
	"|cffFFff00当物品等级数字后面显示|cffFF0000-|r,表示出现了以下情况:|r\n"..
	"|cff00FF00   主手装备了双手武器-但是没有远程|r\n"..
	"|cff00FF00   主手未装备双手武器-但缺失了主手/副手/远程之一|r"
local function add_ItemList(fujik,shiziji)
	local Pname = fujik:GetName()
	local fujiname = Pname.."_ZBLsit"
	if shiziji then
		fujiname=fujiname.."_C"
	end
	local ZBLsit = PIGFrame(fujik,nil,nil,fujiname);
	if GearManagerDialog then GearManagerDialog:SetFrameLevel(10) end
	ZBLsit:PIGSetBackdrop(0.88);
	ZBLsit:SetSize(ListWWWHHH[1],ListWWWHHH[2]);
	if shiziji then
		ZBLsit:SetPoint("TOPLEFT", fujik.ZBLsit, "TOPRIGHT",1,0);
	else
		if tocversion<80000 then
			if ElvUI then
				if fujik==yuanchengCFrame then
					ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",1,0);
				else
					ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",-32,-15);
				end
			elseif NDui then
				if fujik==yuanchengCFrame then
					ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",1,0);
				else
					ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",-32,-15);
				end
			else
				ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",-31,-15);
			end
		else
			if ElvUI or NDui then
				ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",1,0);
			else
				ZBLsit:SetPoint("TOPLEFT", fujik, "TOPRIGHT",0,-2);
			end
		end
	end
	if fujik==CharacterFrame then
		if PaperDollFrame.shuxing then
			PaperDollFrame.shuxing:SetPoint("TOPLEFT", CharacterFrame.ZBLsit, "TOPRIGHT",1,0);
			PaperDollFrame.shuxing:SetPoint("BOTTOMLEFT", CharacterFrame.ZBLsit, "BOTTOMRIGHT",0,0);
		end
	end
	--
	if tocversion<50000 then
		ZBLsit.tishi = CreateFrame("Frame", nil, ZBLsit);
		ZBLsit.tishi:SetSize(18,18);
		ZBLsit.tishi:SetPoint("TOPRIGHT",ZBLsit,"TOPRIGHT",0,0);
		ZBLsit.tishi.Tex = ZBLsit.tishi:CreateTexture();
		ZBLsit.tishi.Tex:SetTexture("interface/common/help-i.blp");
		ZBLsit.tishi.Tex:SetSize(18+8,18+8);
		ZBLsit.tishi.Tex:SetPoint("CENTER");
		PIGEnter(ZBLsit.tishi,addonName.."提示：",tishixx)
	end
	--
	ZBLsit.classes = ZBLsit:CreateTexture();
	ZBLsit.classes:SetTexture("Interface/TargetingFrame/UI-Classes-Circles");
	ZBLsit.classes:SetPoint("TOPLEFT",ZBLsit,"TOPLEFT",3,-3);
	ZBLsit.classes:SetSize(20,20);
	ZBLsit.WJname = PIGFontString(ZBLsit,{"LEFT",ZBLsit.classes,"RIGHT",0,0},"","OUTLINE",15);

	ZBLsit.pingjunLV = PIGFontString(ZBLsit,{"TOPLEFT",ZBLsit,"TOPLEFT",3,-28},STAT_AVERAGE_ITEM_LEVEL..":","OUTLINE");
	ZBLsit.pingjunLV_V = PIGFontString(ZBLsit,{"LEFT",ZBLsit.pingjunLV,"RIGHT",0,0},"n/a","OUTLINE");
	ZBLsit.pingjunLV_V:SetTextColor(1,1,1,1);
	ZBLsit.talentBut = CreateFrame("Button", nil, ZBLsit);
	ZBLsit.talentBut:SetPoint("TOPRIGHT",ZBLsit,"TOPRIGHT",-3,-24);
	ZBLsit.talentBut:SetSize(90,ListWWWHHH[3]+6);
	ZBLsit.talenthilight = ZBLsit.talentBut:CreateTexture(nil,"HIGHLIGHT");
	ZBLsit.talenthilight:SetTexture("interface/paperdollinfoframe/ui-character-tab-highlight.blp");
	ZBLsit.talenthilight:SetPoint("TOPLEFT",ZBLsit.talentBut,"TOPLEFT",-2,6);
	ZBLsit.talenthilight:SetPoint("BOTTOMRIGHT",ZBLsit.talentBut,"BOTTOMRIGHT",4,-6);
	ZBLsit.talenthilight:SetBlendMode("ADD")
	ZBLsit.talentTex = ZBLsit:CreateTexture();
	ZBLsit.talentTex:SetPoint("TOPRIGHT",ZBLsit,"TOPRIGHT",-3,-26);
	ZBLsit.talentTex:SetSize(ListWWWHHH[3],ListWWWHHH[3]);
	ZBLsit.talent_1v = PIGFontString(ZBLsit,{"RIGHT",ZBLsit.talentTex,"LEFT",0,0},"","OUTLINE");
	ZBLsit.talent_1v:SetTextColor(1,1,1,1);
	ZBLsit.talent_1 = PIGFontString(ZBLsit,{"RIGHT",ZBLsit.talent_1v,"LEFT",0,0},SPECIALIZATION..":","OUTLINE");
	PIGLine(ZBLsit,"TOP",-48,nil,{1,-1},{0.2,0.2,0.2,0.9})
	for i=1,#InvSlot["ID"] do
		local clsit = PIGFrame(ZBLsit,nil,nil,fujiname.."_"..InvSlot["ID"][i]);
		clsit:PIGSetBackdrop(0,nil,nil,{1,1,1})
		clsit:SetSize(ListWWWHHH[4],ListWWWHHH[3]);
		if i==1 then
			clsit:SetPoint("TOPLEFT",ZBLsit,"TOPLEFT",3,-54);
		else
			if tocversion<40000 then
				clsit:SetPoint("TOPLEFT",_G[fujiname.."_"..InvSlot["ID"][i-1]],"BOTTOMLEFT",0,-2);
			else
				clsit:SetPoint("TOPLEFT",_G[fujiname.."_"..InvSlot["ID"][i-1]],"BOTTOMLEFT",0,-3.2);
			end
		end
		clsit.t = PIGFontString(clsit,{"CENTER",0.4,0.6},InvSlot["Name"][InvSlot["ID"][i]][2],"OUTLINE",12)
		clsit.itemlink = CreateFrame("Button", nil, clsit)
		clsit.itemlink:SetPoint("LEFT",clsit,"RIGHT",2,0);
		clsit.itemlink:SetSize(100,ListWWWHHH[3]);
		clsit.itemlink.lv = PIGFontString(clsit.itemlink,{"LEFT",clsit.itemlink,"LEFT",0,0},"","OUTLINE")
		clsit.itemlink.t = PIGFontString(clsit.itemlink,{"LEFT",clsit.itemlink.lv,"RIGHT",0,0},"","OUTLINE")
		clsit.itemlink:SetScript("OnLeave", function (self)
			GameTooltip:ClearLines();
			GameTooltip:Hide()
			clsit.t:SetTextColor(0, 1, 1, 0.8);
			clsit:SetBackdropColor(unpack(BackdropColor))
		end);
		for Gemid=1,5 do
			local GemBut = add_GemBut(clsit,Gemid)
		end
	end
	local Dibuline=PIGLine(ZBLsit,"TOP",-396,nil,{1,-1},{0.2,0.2,0.2,0.9})
	for tid=1,6 do
		local taozhuant = PIGFontString(ZBLsit,{"TOPLEFT",Dibuline,"BOTTOMLEFT",2,-3},"","OUTLINE",nil,fujiname.."_".."tao_"..tid);
		if tid==1 then
			taozhuant:SetPoint("TOPLEFT",Dibuline,"BOTTOMLEFT",2,-3);
		else
			taozhuant:SetPoint("TOPLEFT",_G[fujiname.."_".."tao_"..(tid-1)],"BOTTOMLEFT",0,-1);
		end
	end
	function ZBLsit:Update_ItemList()
		if not PIGA["FramePlus"]["Character_ItemList"] then return end
		local Parent=self:GetParent()
		if Parent==CharacterFrame and NDui and NDuiStatPanel and NDuiStatPanel:IsShown() then
			self:SetPoint("TOPLEFT", Parent, "TOPRIGHT",170,-15);
		end
		local ListName = self:GetName()
		local unit=self.unit
		self.jichuxinxi={
			["name"]="n/a",
			["lv"]="n/a",
			["zhiye"]="n/a",
			["Talent"]={"n/a",132222,0},
			["OpenTF"]=function() end,
			["ItemData"]={},
		}
		if unit=="player" then
			self.jichuxinxi.name=GetUnitName("player", true)
			self.jichuxinxi.lv=UnitLevel("player")
			local className, classFilename, classId = UnitClass("player")
			self.jichuxinxi.zhiyeID=classId
			self.jichuxinxi.zhiye=classFilename	
			self.jichuxinxi.OpenTF=function()
				if tocversion<20000 then
					PlayerTalentFrame_LoadUI()
					if PlayerTalentFrame:IsVisible() then
						PlayerTalentFrame:Hide()
					else
						PlayerTalentFrame:Show()
					end
				elseif tocversion<100000 then
					TalentFrame_LoadUI()
					if PlayerTalentFrame:IsVisible() then
						PlayerTalentFrame:Hide()
					else
						PlayerTalentFrame:Show()
					end
				else
					ClassTalentFrame_LoadUI()
					if ClassTalentFrame:IsVisible() then
						ClassTalentFrame:Hide()
					else
						ClassTalentFrame.inspectUnit=nil
						ClassTalentFrame:Show()
					end
				end
			end
			if tocversion<20000 then
				local numTabs = GetNumTalentTabs()
				for ti=1,numTabs do
					local name, icon,pointsSpent = GetTalentTabInfo(ti);
					if pointsSpent>self.jichuxinxi.Talent[3] then
						self.jichuxinxi.Talent={name, icon or 132222, pointsSpent}
					end
				end
			elseif tocversion<50000 then
				local index = GetActiveTalentGroup()
				local numTabs = GetNumTalentTabs()
				for ti=1,numTabs do
					local name, icon,pointsSpent = GetTalentTabInfo(ti,false,false,index);
					if pointsSpent>self.jichuxinxi.Talent[3] then
						self.jichuxinxi.Talent={name, icon or 132222, pointsSpent}
					end
				end
			else
				local specIndex = GetSpecialization()--当前专精
				local id, name, description, icon = GetSpecializationInfo(specIndex)
				self.jichuxinxi.Talent={name, icon or 132222, 1}
			end
		else
			if unit=="yc" then
				local Data_WJ=yuanchengCFrame.Data_Info[1]
				self.jichuxinxi.name=yuanchengCFrame.fullnameX
				self.jichuxinxi.lv=Data_WJ.level
				self.jichuxinxi.zhiyeID=Data_WJ.class
				local classInfo = C_CreatureInfo.GetClassInfo(Data_WJ.class)
				self.jichuxinxi.zhiye=classInfo["classFile"]
				self.jichuxinxi.OpenTF=function()
					PlaySound(SOUNDKIT.IG_CHAT_EMOTE_BUTTON);
					if Parent.TalentF:IsVisible() then
						Parent.TalentF:Hide()
					else
						Parent.TalentF:Show()
					end
				end
				self.jichuxinxi.Talent=yuanchengCFrame.zhuanjing or self.jichuxinxi.Talent
			else
				self.jichuxinxi.name=GetUnitName(unit, true)
				self.jichuxinxi.lv=UnitLevel(unit)
				local className, classFilename, classId = UnitClass(unit)
				self.jichuxinxi.zhiyeID=classId
				self.jichuxinxi.zhiye=classFilename	
				if tocversion<20000 then

				elseif tocversion<50000 then
					self.jichuxinxi.OpenTF=function()
						InspectFrameTab3:Click()
					end
					local index = GetActiveTalentGroup(true,false)
					local numTabs = GetNumTalentTabs(true)
					for ti=1,numTabs do
						local name, icon,pointsSpent = GetTalentTabInfo(ti,true,false,index);
						if pointsSpent>self.jichuxinxi.Talent[3] then
							self.jichuxinxi.Talent={name, icon or 132222, pointsSpent}
						end
					end
				else
					self.jichuxinxi.OpenTF=function()
						--if C_Traits.HasValidInspectData() then
						if InCombatLockdown() then
							PlaySound(SOUNDKIT.IG_CHAT_EMOTE_BUTTON);
							PIGinfotip:TryDisplayMessage("请专心战斗", YELLOW_FONT_COLOR:GetRGB());
						else
							InspectPaperDollItemsFrame.InspectTalents:Click()
						end
					end
					local specID = GetInspectSpecialization(unit)
					local id, name, description, icon = GetSpecializationInfoByID(specID)
					self.jichuxinxi.Talent={name, icon or 132222, 1}
				end
			end
		end
		self.WJname:SetText(self.jichuxinxi.name.."|cffFFFF22 ("..self.jichuxinxi.lv..")|r")
		if self.jichuxinxi.zhiye~="n/a" then
			self.classes:SetTexCoord(unpack(CLASS_ICON_TCOORDS[self.jichuxinxi.zhiye]));
			local color = RAID_CLASS_COLORS[self.jichuxinxi.zhiye]
			self.WJname:SetTextColor(color.r, color.g, color.b,1);
		end
		--天赋
		self.talent_1v:SetText(self.jichuxinxi.Talent[1])
		self.talentTex:SetTexture(self.jichuxinxi.Talent[2]);
		local zhixingCC = self.jichuxinxi.OpenTF
		self.talentBut:SetScript("OnClick", function (self)
			zhixingCC()
		end)
		--重置装备列表
		for i = 1, #InvSlot["ID"] do
			local fujikk = _G[ListName.."_"..InvSlot["ID"][i]]
			CZ_ItemListinfo(fujikk,InvSlot["ID"][i],ListName)
		end
		CZ_taozhuanginfo(self,ListName)--CZ套装信息
		----
		if self.Getwupinmulu then self.Getwupinmulu:Cancel() end
		self.Getwupinmulu=C_Timer.NewTimer(0.2,function()
			Getwupinmulu(self,unit)
		end)
	end
	return ZBLsit
end
function Create.PIGItemListUI(laiyuan)
	if laiyuan.ZBLsit then return end
	if laiyuan==CharacterFrame then laiyuan=PaperDollFrame end
	laiyuan.ZBLsit = add_ItemList(laiyuan)
	if laiyuan==CharacterFrame then
		laiyuan.ZBLsit.unit="player"
		UIPanelWindows["CharacterFrame"].width = 600
	elseif laiyuan==InspectFrame then
		UIPanelWindows["InspectFrame"].width = 880
		laiyuan.ZBLsit_C = add_ItemList(laiyuan,true)
		laiyuan.ZBLsit_C.unit="player"
	elseif laiyuan==yuanchengCFrame then
		laiyuan.ZBLsit.unit="yc"
		laiyuan.ZBLsit_C = add_ItemList(laiyuan,true)
		laiyuan.ZBLsit_C.unit="player"
	end
end
-- hooksecurefunc("NotifyInspect", function(unit)
-- 	print(unit)
-- end)