local addonName, addonTable = ...;
local sub = _G.string.sub
local _, _, _, tocversion = GetBuildInfo()
local Create = addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGFontString=Create.PIGFontString
local PIGItemListUI=Create.PIGItemListUI
-------------
local InvSlot=addonTable.Data.InvSlot
local YC_TalentInfo=addonTable.YC_TalentInfo
local tianfuW,tianfuH = YC_TalentInfo.tianfuW,YC_TalentInfo.tianfuH
local PIGtianfuhangshu = YC_TalentInfo.PIGtianfuhangshu
local tianfuID = YC_TalentInfo.tianfuID
local tianfuBG = YC_TalentInfo.tianfuBG
local tianfuTabName = YC_TalentInfo.tianfuTabName
local tianfuTabIcon = YC_TalentInfo.tianfuTabIcon
--ElvUI=true
--暴雪角色装备界面+装备列表
local function ADD_CharacterFrame(fuji,Point,laiyuan,FrameLevel)
	local frameX
	if ElvUI or NDui then
		frameX = PIGFrame(fuji,Point,{340,419},laiyuan,true)
		if tocversion<80000 then
			if ElvUI then
				frameX:SetSize(336,419);
			elseif NDui then
				frameX:SetSize(334,419);
			end
		end
		if Point then
			if ElvUI then
				frameX:SetPoint(Point[1],Point[2],Point[3],Point[4]+12,Point[5]-13);
			else
				frameX:SetPoint(Point[1],Point[2],Point[3],Point[4]+15,Point[5]-14);
			end
		end
		frameX:PIGSetBackdrop()
		frameX:PIGSetMovable()
		frameX:SetUserPlaced(false)
		frameX:SetScript("OnDragStop",function()
			frameX:StopMovingOrSizing()
			frameX:SetUserPlaced(false) 
		end)
		frameX:PIGClose();
		frameX.TitleText = PIGFontString(frameX,{"TOP", frameX, "TOP",8, -8},"")
		frameX.LevelText = PIGFontString(frameX,{"TOP", frameX, "TOP",8, -34},"")
		frameX.InspectPaperDoll = CreateFrame("Frame", nil, frameX)
		frameX.InspectPaperDoll:SetPoint("TOPLEFT",frameX,"TOPLEFT",2,-56)
		frameX.InspectPaperDoll:SetPoint("BOTTOMRIGHT",frameX,"BOTTOMRIGHT",-6,4)
	else
		if tocversion<80000 then
			frameX = CreateFrame("Frame", laiyuan, fuji)
			frameX:SetSize(384,512);
			if Point then
				frameX:SetPoint(Point[1],Point[2],Point[3],Point[4],Point[5]);
			end
			frameX:SetMovable(true)	
			frameX:SetUserPlaced(false) 
		    frameX.Portrait_BG = frameX:CreateTexture(nil, "BACKGROUND");
			frameX.Portrait_BG:SetTexture("interface/buttons/iconborder-glowring.blp");
			frameX.Portrait_BG:SetSize(60,60);
			frameX.Portrait_BG:SetPoint("TOPLEFT",frameX,"TOPLEFT",9,-7.8);
			frameX.Portrait_BG:SetDrawLayer("BACKGROUND", -2)
			frameX.Portrait_BGmask = frameX:CreateMaskTexture()
			frameX.Portrait_BGmask:SetAllPoints(frameX.Portrait_BG)
			frameX.Portrait_BGmask:SetTexture("Interface/CHARACTERFRAME/TempPortraitAlphaMask", "CLAMPTOBLACKADDITIVE", "CLAMPTOBLACKADDITIVE")
			frameX.Portrait_BG:AddMaskTexture(frameX.Portrait_BGmask)
			frameX.Portrait = frameX:CreateTexture(nil, "BACKGROUND");
			frameX.Portrait:SetSize(60,60);
		    frameX.Portrait:SetPoint("TOPLEFT", frameX, "TOPLEFT", 8, -7);
		    frameX.InspectName = CreateFrame("Frame", nil, frameX)
		    frameX.InspectName:SetSize(180,16);
		    frameX.InspectName:SetPoint("TOP", frameX, "TOP", 8, -17);
		    frameX.InspectName:SetFrameLevel(frameX.InspectName:GetFrameLevel()+2)
			frameX.InspectName:EnableMouse(true)
			frameX.InspectName:RegisterForDrag("LeftButton")
			frameX.InspectName:SetScript("OnDragStart",function(self)
				frameX:StartMoving()
			end)
			frameX.InspectName:SetScript("OnDragStop",function(self)
				frameX:StopMovingOrSizing()
				frameX:SetUserPlaced(false) 
			end)
			frameX.InspectName:SetClampedToScreen(true)
		   	frameX.TitleText = PIGFontString(frameX.InspectName,{"CENTER", frameX.InspectName, "CENTER",0, 0},"")
			frameX.LevelText = PIGFontString(frameX.InspectName,{"TOP", frameX, "TOP",8, -40},"")
			frameX.Close = CreateFrame("Button",nil,frameX, "UIPanelCloseButton");
		    frameX.Close:SetPoint("CENTER", frameX, "TOPRIGHT", -44, -25);
		   
			frameX.InspectPaperDoll = CreateFrame("Frame", nil, frameX)
			frameX.InspectPaperDoll:SetAllPoints(frameX)
			frameX.InspectPaperDoll.L1 = frameX.InspectPaperDoll:CreateTexture(nil, "BORDER");
		    frameX.InspectPaperDoll.L1:SetTexture("Interface/PaperDollInfoFrame/UI-Character-CharacterTab-L1");
		    frameX.InspectPaperDoll.L1:SetSize(256,256);
		    frameX.InspectPaperDoll.L1:SetPoint("TOPLEFT");
		    frameX.InspectPaperDoll.R1 = frameX.InspectPaperDoll:CreateTexture(nil, "BORDER");
		    frameX.InspectPaperDoll.R1:SetTexture("Interface/PaperDollInfoFrame/UI-Character-CharacterTab-R1");
		    frameX.InspectPaperDoll.R1:SetSize(128,256);
		    frameX.InspectPaperDoll.R1:SetPoint("TOPLEFT",256,0);
		    frameX.InspectPaperDoll.R1 = frameX.InspectPaperDoll:CreateTexture(nil, "BORDER");
		    frameX.InspectPaperDoll.R1:SetTexture("Interface/PaperDollInfoFrame/UI-Character-CharacterTab-BottomLeft");
		    frameX.InspectPaperDoll.R1:SetSize(256,256);
		    frameX.InspectPaperDoll.R1:SetPoint("TOPLEFT",0,-256);
		    frameX.InspectPaperDoll.R1 = frameX.InspectPaperDoll:CreateTexture(nil, "BORDER");
		    frameX.InspectPaperDoll.R1:SetTexture("Interface/PaperDollInfoFrame/UI-Character-CharacterTab-BottomRight");
		    frameX.InspectPaperDoll.R1:SetSize(128,256);
		    frameX.InspectPaperDoll.R1:SetPoint("TOPLEFT",256,-256);
		else
			frameX = CreateFrame("Frame", laiyuan, fuji,"ButtonFrameTemplate")
			frameX:SetSize(338,424);
			if Point then
				frameX:SetPoint(Point[1],Point[2],Point[3],Point[4]+16,Point[5]-12);
			end
			frameX.Inset:SetPoint("BOTTOMRIGHT", frameX, "BOTTOMRIGHT", -6, 4);
			frameX.InspectPaperDoll = frameX.Inset
			frameX.Portrait=_G[laiyuan.."Portrait"]
			frameX.TitleText = frameX.TitleContainer.TitleText
			frameX.LevelText = PIGFontString(frameX.TitleContainer,{"TOP", frameX, "TOP",8, -30},"")	
		end
		frameX:Hide()
		tinsert(UISpecialFrames,laiyuan);
	end
	--
	frameX.TitleText:SetTextColor(1, 1, 1, 1)
	frameX.tishi = CreateFrame("Frame", nil, frameX)
    frameX.tishi:SetSize(200,150);
    if tocversion<80000 then
    	frameX.tishi:SetPoint("CENTER", frameX, "CENTER", 0, 30);
    else
    	frameX.tishi:SetPoint("CENTER", frameX, "CENTER", 10, 30);
    end	
    frameX.tishi:SetFrameLevel(frameX:GetFrameLevel()+3)
    frameX.tishi.t = PIGFontString(frameX.tishi,{"CENTER", frameX.tishi, "CENTER",-4, 20})
	---
	if FrameLevel then
		frameX:SetFrameLevel(FrameLevel)
	end
	--
	frameX.InspectPaperDoll.Items = CreateFrame("Frame", nil, frameX.InspectPaperDoll)
	frameX.InspectPaperDoll.Items:SetPoint("TOPLEFT",frameX.InspectPaperDoll,"TOPLEFT",0,0)
	frameX.InspectPaperDoll.Items:SetPoint("BOTTOMRIGHT",frameX.InspectPaperDoll,"BOTTOMRIGHT",0,0)
	
	local uiWidth=CharacterHeadSlot:GetWidth()
	for i=1,#InvSlot["CID"] do
		local item
		if tocversion<100000 then
			item = CreateFrame("Button", laiyuan.."_item_"..InvSlot["CID"][i], frameX.InspectPaperDoll.Items);
			item:SetHighlightTexture(130718);
			item.icon = item:CreateTexture()
			item.icon:SetAllPoints(item)
		else
			item = CreateFrame("ItemButton", laiyuan.."_item_"..InvSlot["CID"][i], frameX.InspectPaperDoll.Items);
		end
		item:SetSize(uiWidth,uiWidth);
		item.Frame = item:CreateTexture(nil, "BACKGROUND")
		if ElvUI or NDui then
			item.icon:SetTexCoord(0.08,0.92,0.08,0.92)
			--item.NormalTexture:SetAlpha(0)
			item.Frame:SetTexture("");
		else
			item.Frame:SetTexture("Interface/CharacterFrame/Char-Paperdoll-Parts");
		end
		item.Frame:SetDrawLayer("BACKGROUND", -1)
		if i<17 then
			item.Frame:SetSize(uiWidth*1.3,uiWidth*1.26);
			if i<9 then 
				item.Frame:SetTexCoord(0.20703125,0.39843750,0.59375000,0.93750000)
				item.Frame:SetPoint("TOPLEFT",item,"TOPLEFT",-4.4,2);
			end
			if i>8 and i<17 then
				item.Frame:SetTexCoord(0.00390625,0.19921875,0.59375000,0.93750000)
				item.Frame:SetPoint("TOPRIGHT",item,"TOPRIGHT",4,2);
			end
			if i==1 then
				if tocversion<80000 then
					if ElvUI or NDui then
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",4,-4);
					else
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",21,-74);
					end
				else
					item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",6,-4);
				end
			elseif i==9 then
				if tocversion<80000 then
					if ElvUI or NDui then
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",290,-4);
					else
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",306,-74);
					end
				else
					item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"TOPLEFT",290,-4);
				end
			else
				item:SetPoint("TOP", _G[laiyuan.."_item_"..(InvSlot["CID"][i-1])], "BOTTOM", 0, -4);
			end
		else
			item.Frame:SetSize(uiWidth*1.16,uiWidth*1.42);
			item.Frame:SetTexCoord(0.67187500,0.83593750,0.00781250,0.42187500)
			item.Frame:SetPoint("TOPLEFT",item,"TOPLEFT",-4,8);
			if i==17 then
				if tocversion<80000 then
					if ElvUI or NDui then
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"BOTTOMLEFT",104,44);
					else
						item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"BOTTOMLEFT",122,127);
					end
				else
					item:SetPoint("TOPLEFT",frameX.InspectPaperDoll.Items,"BOTTOMLEFT",122,49);
				end
			else
				item:SetPoint("LEFT", _G[laiyuan.."_item_"..(InvSlot["CID"][i-1])], "RIGHT", 4, 0);
			end
		end
		item.LV = PIGFontString(item,{"TOPRIGHT", item, "TOPRIGHT", 0,-1},nil,"OUTLINE")
		item.ranse = item:CreateTexture(nil, "OVERLAY");
	    item.ranse:SetTexture("Interface/Buttons/UI-ActionButton-Border");
	    item.ranse:SetBlendMode("ADD");
	    item.ranse:SetSize(uiWidth*1.74,uiWidth*1.74);
	    item.ranse:SetPoint("CENTER", item, "CENTER", 0, 0);
	    item.ranse:Hide()
	end
	---装备列表
	PIGItemListUI(frameX)
	--天赋
	frameX.TalentF = PIGFrame(frameX,{"TOPLEFT", frameX.ZBLsit, "TOPRIGHT", 1, 0},{tianfuW+140,tianfuH});
	frameX.TalentF:PIGSetBackdrop(1);
	frameX.TalentF:SetFrameLevel(frameX.TalentF:GetFrameLevel()+6)
	frameX.TalentF:Hide()
	frameX.TalentF:PIGClose()
	frameX.TalentF.L_TOPLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.L_TOPLEFT:SetSize(tianfuW/3,tianfuH-104);
	frameX.TalentF.L_TOPLEFT:SetPoint("TOPLEFT", frameX.TalentF, "TOPLEFT",4, -24);
	frameX.TalentF.L_TOPRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.L_TOPRIGHT:SetPoint("TOPLEFT", frameX.TalentF.L_TOPLEFT, "TOPRIGHT",0, 0);
	frameX.TalentF.L_TOPRIGHT:SetPoint("BOTTOMLEFT", frameX.TalentF.L_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.L_BOTTOMLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.L_BOTTOMLEFT:SetPoint("TOPLEFT", frameX.TalentF.L_TOPLEFT, "BOTTOMLEFT",0, 0);
	frameX.TalentF.L_BOTTOMLEFT:SetPoint("TOPRIGHT", frameX.TalentF.L_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.L_BOTTOMRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.L_BOTTOMRIGHT:SetPoint("TOPLEFT", frameX.TalentF.L_BOTTOMLEFT, "TOPRIGHT",0, 0);
	---
	frameX.TalentF.C_TOPLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.C_TOPLEFT:SetWidth(tianfuW/3);
	frameX.TalentF.C_TOPLEFT:SetPoint("TOPLEFT", frameX.TalentF.L_TOPRIGHT, "TOPRIGHT",-20, 0);
	frameX.TalentF.C_TOPLEFT:SetPoint("BOTTOMLEFT", frameX.TalentF.L_TOPRIGHT, "BOTTOMRIGHT",-20, 0);
	frameX.TalentF.C_TOPRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.C_TOPRIGHT:SetPoint("TOPLEFT", frameX.TalentF.C_TOPLEFT, "TOPRIGHT",0, 0);
	frameX.TalentF.C_TOPRIGHT:SetPoint("BOTTOMLEFT", frameX.TalentF.C_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.C_BOTTOMLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.C_BOTTOMLEFT:SetPoint("TOPLEFT", frameX.TalentF.C_TOPLEFT, "BOTTOMLEFT",0, 0);
	frameX.TalentF.C_BOTTOMLEFT:SetPoint("TOPRIGHT", frameX.TalentF.C_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.C_BOTTOMRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.C_BOTTOMRIGHT:SetPoint("TOPLEFT", frameX.TalentF.C_BOTTOMLEFT, "TOPRIGHT",0, 0);
	---
	frameX.TalentF.R_TOPLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.R_TOPLEFT:SetWidth(tianfuW/3);
	frameX.TalentF.R_TOPLEFT:SetPoint("TOPLEFT", frameX.TalentF.C_TOPRIGHT, "TOPRIGHT",-20, 0);
	frameX.TalentF.R_TOPLEFT:SetPoint("BOTTOMLEFT", frameX.TalentF.C_TOPRIGHT, "BOTTOMRIGHT",-20, 0);
	frameX.TalentF.R_TOPRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.R_TOPRIGHT:SetPoint("TOPLEFT", frameX.TalentF.R_TOPLEFT, "TOPRIGHT",0, 0);
	frameX.TalentF.R_TOPRIGHT:SetPoint("BOTTOMLEFT", frameX.TalentF.R_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.R_BOTTOMLEFT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.R_BOTTOMLEFT:SetPoint("TOPLEFT", frameX.TalentF.R_TOPLEFT, "BOTTOMLEFT",0, 0);
	frameX.TalentF.R_BOTTOMLEFT:SetPoint("TOPRIGHT", frameX.TalentF.R_TOPLEFT, "BOTTOMRIGHT",0, 0);
	frameX.TalentF.R_BOTTOMRIGHT = frameX.TalentF:CreateTexture(nil, "BORDER");
	frameX.TalentF.R_BOTTOMRIGHT:SetPoint("TOPLEFT", frameX.TalentF.R_BOTTOMLEFT, "TOPRIGHT",0, 0);
	--
	frameX.TalentF.biaoti = PIGFontString(frameX.TalentF,{"TOP", frameX.TalentF, "TOP", 0,-6})
	frameX.TalentF.biaoti1 = PIGFontString(frameX.TalentF,{"LEFT", frameX.TalentF.biaoti, "RIGHT", 0,0})
	--
	frameX.TalentF.ZJ1 = PIGFontString(frameX.TalentF,{"TOPLEFT", frameX.TalentF, "TOPLEFT", 84,-27},nil,nil,nil,"TalentFYIDIAN1");
	frameX.TalentF.ZJ2 = PIGFontString(frameX.TalentF,{"TOPLEFT", frameX.TalentF, "TOPLEFT", 300,-27},nil,nil,nil,"TalentFYIDIAN2");
	frameX.TalentF.ZJ3 = PIGFontString(frameX.TalentF,{"TOPLEFT", frameX.TalentF, "TOPLEFT", 510,-27},nil,nil,nil,"TalentFYIDIAN3");
	---
	local tianfuB= 30
	for i=1,3 do
		for ii=1,PIGtianfuhangshu do
			for iii=1,4 do
				local tianfuBUT = CreateFrame("Button", "tianfuBUT_"..i.."_"..ii.."_"..iii, frameX.TalentF);
				tianfuBUT:SetHighlightTexture(130718);
				tianfuBUT:SetSize(tianfuB,tianfuB);
				if i==1 then
					if ii==1 then
						if iii==1 then
							tianfuBUT:SetPoint("TOPLEFT",frameX.TalentF,"TOPLEFT",20,-46);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					else
						if iii==1 then
							tianfuBUT:SetPoint("TOP",_G["tianfuBUT_"..i.."_"..(ii-1).."_"..iii],"BOTTOM", 0, -18);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					end
				elseif i==2 then
					if ii==1 then
						if iii==1 then
							tianfuBUT:SetPoint("TOPLEFT",frameX.TalentF,"TOPLEFT",236,-46);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					else
						if iii==1 then
							tianfuBUT:SetPoint("TOP",_G["tianfuBUT_"..i.."_"..(ii-1).."_"..iii],"BOTTOM", 0, -18);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					end
				elseif i==3 then
					if ii==1 then
						if iii==1 then
							tianfuBUT:SetPoint("TOPLEFT",frameX.TalentF,"TOPLEFT",444,-46);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					else
						if iii==1 then
							tianfuBUT:SetPoint("TOP",_G["tianfuBUT_"..i.."_"..(ii-1).."_"..iii],"BOTTOM", 0, -18);
						else
							tianfuBUT:SetPoint("LEFT", _G["tianfuBUT_"..i.."_"..ii.."_"..(iii-1)], "RIGHT", 20, 0);
						end
					end
				end
				tianfuBUT.Border = tianfuBUT:CreateTexture(nil, "BORDER");
				tianfuBUT.Border:SetTexture(130841);
				tianfuBUT.Border:SetPoint("TOPLEFT",tianfuBUT,"TOPLEFT",-10,10);
				tianfuBUT.Border:SetPoint("BOTTOMRIGHT",tianfuBUT,"BOTTOMRIGHT",10,-10);
				tianfuBUT.Icon = tianfuBUT:CreateTexture(nil, "BORDER");
				tianfuBUT.Icon:SetPoint("TOPLEFT",tianfuBUT,"TOPLEFT",0,0);
				tianfuBUT.Icon:SetPoint("BOTTOMRIGHT",tianfuBUT,"BOTTOMRIGHT",0,0);
				tianfuBUT.dianshuBG = tianfuBUT:CreateTexture(nil, "ARTWORK");
				tianfuBUT.dianshuBG:SetTexture("interface/talentframe/talentframe-rankborder.blp");
				tianfuBUT.dianshuBG:SetSize(tianfuB*1.74,tianfuB);
				tianfuBUT.dianshuBG:SetPoint("BOTTOMRIGHT",tianfuBUT,"BOTTOMRIGHT",25,-14);
				tianfuBUT.dianshu = PIGFontString(tianfuBUT,{"CENTER", tianfuBUT.dianshuBG, "CENTER", 1,1},nil,nil,12)
			end
		end
	end
	return frameX
end
--Create.CharacterFrame=ADD_CharacterFrame
--------------------------------------------
local SendAddonMessage = C_ChatInfo and C_ChatInfo.SendAddonMessage or SendAddonMessage;
local biaotou="!Pig-YCIN";
local YCinfo_GET_MSG = {"!GETALL","!GETTF"};
local RegisterAddonMessagePrefix = C_ChatInfo and C_ChatInfo.RegisterAddonMessagePrefix or RegisterAddonMessagePrefix;
local IsAddonMessagePrefixRegistered = C_ChatInfo and C_ChatInfo.IsAddonMessagePrefixRegistered or IsAddonMessagePrefixRegistered;
RegisterAddonMessagePrefix(biaotou)
--
local ala_PREFIX = "ATEADD"
---------------
local ycnewframeFF = CreateFrame("Frame")
ycnewframeFF:RegisterEvent("PLAYER_LOGIN")
ycnewframeFF:SetScript("OnEvent",function()
	ADD_CharacterFrame(UIParent,{"TOPLEFT",UIParent,"TOPLEFT",0, -104},"yuanchengCFrame",99)
	C_Timer.After(3,function()
		if not IsAddonMessagePrefixRegistered(ala_PREFIX) then
			RegisterAddonMessagePrefix(ala_PREFIX)
		end
	end)
end)
--------
local function Update_ShowTianfu()
	local Data_WJ=yuanchengCFrame.Data_Info[1]
	local level=Data_WJ.level
	local class=Data_WJ.class
	local classInfo = C_CreatureInfo.GetClassInfo(class)
	local zhiye=classInfo["classFile"]
	yuanchengCFrame.TalentF.L_TOPLEFT:SetTexture(tianfuBG[zhiye][3]);
	yuanchengCFrame.TalentF.L_TOPRIGHT:SetTexture(tianfuBG[zhiye][4]);
	yuanchengCFrame.TalentF.L_BOTTOMLEFT:SetTexture(tianfuBG[zhiye][1]);
	yuanchengCFrame.TalentF.L_BOTTOMRIGHT:SetTexture(tianfuBG[zhiye][2]);
	--
	yuanchengCFrame.TalentF.C_TOPLEFT:SetTexture(tianfuBG[zhiye][7]);
	yuanchengCFrame.TalentF.C_TOPRIGHT:SetTexture(tianfuBG[zhiye][8]);
	yuanchengCFrame.TalentF.C_BOTTOMLEFT:SetTexture(tianfuBG[zhiye][5]);
	yuanchengCFrame.TalentF.C_BOTTOMRIGHT:SetTexture(tianfuBG[zhiye][6]);
	---
	yuanchengCFrame.TalentF.R_TOPLEFT:SetTexture(tianfuBG[zhiye][11]);
	yuanchengCFrame.TalentF.R_TOPRIGHT:SetTexture(tianfuBG[zhiye][12]);
	yuanchengCFrame.TalentF.R_BOTTOMLEFT:SetTexture(tianfuBG[zhiye][9]);
	yuanchengCFrame.TalentF.R_BOTTOMRIGHT:SetTexture(tianfuBG[zhiye][10]);
	local tianfudata = {
		["xulie"]=0,["dangqian"]={"n/a",132222,0},
		[1]=0,[2]=0,[3]=0,
	}
	local Data_Info3=yuanchengCFrame.Data_Info[3]
	local xnum = strlen(Data_Info3)
	local TFinfo = {}
	for i=1,xnum do
		TFinfo[i]=Data_Info3:sub(i,i)
	end
	for i=1,3 do
		for ii=1,PIGtianfuhangshu do
			for iii=1,4 do
				local tianfuF = _G["tianfuBUT_"..i.."_"..ii.."_"..iii]
				if tianfuID[zhiye][i][ii][iii] then
					tianfudata.xulie=tianfudata.xulie+1
					local huoqudianshu=tonumber(TFinfo[tianfudata.xulie])
					local huoqudianshu=huoqudianshu or 0
					tianfudata[i]=tianfudata[i]+huoqudianshu
					tianfuF.dianshu.yijiadian=huoqudianshu
					tianfuF.dianshu:SetText(huoqudianshu.."/"..(#tianfuID[zhiye][i][ii][iii]));
					if huoqudianshu==#tianfuID[zhiye][i][ii][iii] then
						tianfuF.dianshu:SetTextColor(1, 1, 0, 1);
					else
						tianfuF.dianshu:SetTextColor(0, 1, 0, 1);
					end
					tianfuF.Icon:SetTexture(GetSpellTexture(tianfuID[zhiye][i][ii][iii][1]))
					tianfuF.dianshu:Show()
					tianfuF.dianshuBG:Show()
					tianfuF:Show();
					if huoqudianshu>0 then
						tianfuF.Icon:SetDesaturated(false)
						tianfuF:SetScript("OnEnter", function (self)
							GameTooltip:ClearLines();
							GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
							GameTooltip:SetHyperlink("spell:"..tianfuID[zhiye][i][ii][iii][huoqudianshu])
							GameTooltip:Show();
						end);
					else
						tianfuF.Icon:SetDesaturated(true)
						tianfuF:SetScript("OnEnter", function (self)
							GameTooltip:ClearLines();
							GameTooltip:SetOwner(self,"ANCHOR_RIGHT");
							GameTooltip:SetHyperlink("spell:"..tianfuID[zhiye][i][ii][iii][1])
							GameTooltip:Show();
						end);
					end
					tianfuF:SetScript("OnLeave", function ()
						GameTooltip:ClearLines();
						GameTooltip:Hide() 
					end);

				else
					tianfuF:Hide();
				end
			end
		end
		if tianfudata[i]>tianfudata.dangqian[3] then
			tianfudata.dangqian={tianfuTabName[zhiye][i],tianfuTabIcon[zhiye][i],tianfudata[i]}
		end
		_G["TalentFYIDIAN"..i]:SetText(tianfuTabName[zhiye][i].."("..tianfudata[i]..")");
	end
	yuanchengCFrame.zhuanjing=tianfudata.dangqian
	local yiyongzongdianshu=tianfudata[1]+tianfudata[2]+tianfudata[3]
	--
	local zongdianshu = max(tonumber(level)-9,0)
	yuanchengCFrame.TalentF.biaoti:SetText("当前可用点数"..zongdianshu);
	yuanchengCFrame.TalentF.biaoti1:SetText("(已分配"..yiyongzongdianshu..")");
	local shengyu = zongdianshu-yiyongzongdianshu
	for i=1,3 do
		for ii=1,PIGtianfuhangshu do
			for iii=1,4 do
				local tianfuF = _G["tianfuBUT_"..i.."_"..ii.."_"..iii]
				if tianfuID[zhiye][i][ii][iii] then
					if tianfuF.dianshu.yijiadian==0 and shengyu==0 then
						tianfuF.dianshu:Hide()
						tianfuF.dianshuBG:Hide()
					end
				end
			end
		end
	end
end
----
local function Update_ShowItem_List()
	local zbinfo=yuanchengCFrame.Data_Info[2]
	for i=1,#InvSlot["ALLID"] do
		local invFff = _G["yuanchengCFrame_item_"..InvSlot["ALLID"][i]]
		invFff:SetScript("OnLeave", function ()
			GameTooltip:ClearLines();
			GameTooltip:Hide() 
		end);
		if zbinfo[InvSlot["ALLID"][i]] then
			local itemName,itemLink,itemQuality,itemLevel,itemMinLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,itemTexture= GetItemInfo(zbinfo[InvSlot["ALLID"][i]])
			SetItemButtonTexture(invFff, itemTexture);
			invFff:SetScript("OnEnter", function (self)
				GameTooltip:ClearLines();
				GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
				GameTooltip:SetHyperlink(itemLink)
				GameTooltip:Show();
			end);
			if InvSlot["ALLID"][i]~=4 and InvSlot["ALLID"][i]~=19 then
				if PIGA["FramePlus"]["Character_ItemLevel"] then
					if itemLevel and itemLevel>0 then
						invFff.LV:SetText(itemLevel)
						local r, g, b, hex = GetItemQualityColor(itemQuality)
						invFff.LV:SetTextColor(r, g, b, 1);
					end
				end
				if PIGA["FramePlus"]["Character_ItemColor"] then
				    if itemQuality and itemQuality>1 then
				        local r, g, b = GetItemQualityColor(itemQuality);
				        invFff.ranse:SetVertexColor(r, g, b);
						invFff.ranse:Show()
					end
				end
			end
		end
	end
	yuanchengCFrame.ZBLsit:Update_ItemList()
	yuanchengCFrame.ZBLsit_C:Update_ItemList()
end
local function Update_ShowItem()
	local zbinfo=yuanchengCFrame.Data_Info[2]
	local linshihuoquList = {}
	local huancunwan = 0
	for k,v in pairs(zbinfo) do
		huancunwan=huancunwan+1
	end
	for k,v in pairs(zbinfo) do
		local itemID = GetItemInfoInstant(v)
		if itemID and itemID>0 then
			local item = Item:CreateFromItemID(itemID)
			linshihuoquList[item] = true
			item:ContinueOnItemLoad(function()
				linshihuoquList[item] = nil
				huancunwan=huancunwan-1
				if huancunwan==0 then
					Update_ShowItem_List()
				end
			end)
		end
	end
end
local function Update_ShowPlayer()
	local Data_WJ=yuanchengCFrame.Data_Info[1]
	local level=Data_WJ.level
	local class=Data_WJ.class
	local race=Data_WJ.race
	local classInfo = C_CreatureInfo.GetClassInfo(class)
	local raceName = "  "
	if tonumber(race)>0 then
		local raceInfo = C_CreatureInfo.GetRaceInfo(race)
		raceName=raceInfo["raceName"]
	end
	if not ElvUI and not NDui then
		yuanchengCFrame.Portrait:SetTexture("interface/targetingframe/ui-classes-circles.blp")
		local coords = CLASS_ICON_TCOORDS[classInfo["classFile"]]
		yuanchengCFrame.Portrait:SetTexCoord(unpack(coords));
	end
	yuanchengCFrame.LevelText:SetText(LEVEL..level.." "..raceName.." "..classInfo["className"]);
end
--获取到目标信息
local ALA=addonTable.ALA
local function Pig_YC_data()
	local yc_data=yuanchengCFrame.yc_msg
	yuanchengCFrame.Data_Info=ALA.tiquData(yc_data,yuanchengCFrame.ly)
	Update_ShowPlayer()
	Update_ShowTianfu()
	Update_ShowItem()
end
----
local function alaGet_Fun()
	if not yuanchengCFrame.fanhuiYN then
		SendAddonMessage(ala_PREFIX, "!Q32TGE", "WHISPER", yuanchengCFrame.fullnameX);
	end
end
local function ycNull_Fun()
	if not yuanchengCFrame.fanhuiYN then
		yuanchengCFrame.LevelText:SetText("|cffFF0000获取失败\n目标未安装!Pig插件或版本过期|r");
	end
end
----重置远程UI数据
local function CZ_yuanchengCData(gongneng)
	yuanchengCFrame.fanhuiYN=false
	yuanchengCFrame.yc_msg = ""
	yuanchengCFrame.Data_Info={}
	yuanchengCFrame.LevelText:SetText("|cffFFFF00正在获取目标信息...|r");
	yuanchengCFrame.tishi.t:SetText("!Pig\n"..gongneng..INSPECT)
	if not ElvUI and not NDui then
		yuanchengCFrame.Portrait:SetTexture(130899)
		yuanchengCFrame.Portrait:SetTexCoord(0,1,0,1);
	end
	for i=1,#InvSlot["CID"] do
		local fujiframe = _G["yuanchengCFrame_item_"..InvSlot["CID"][i]]
		fujiframe.LV:SetText("")
		fujiframe.ranse:Hide()
		local invSlotId,SlotTexture = GetInventorySlotInfo(InvSlot["Name"][InvSlot["CID"][i]][1])
		fujiframe.icon:SetTexture(SlotTexture)
		fujiframe:SetScript("OnEnter", nil);
		fujiframe:SetScript("OnLeave", nil);
	end
	---
	yuanchengCFrame.TalentF:Hide()
	yuanchengCFrame.TalentF.biaoti:SetText();
	yuanchengCFrame.TalentF.biaoti1:SetText();
	--
	yuanchengCFrame.TalentF.L_TOPLEFT:SetTexture("");
	yuanchengCFrame.TalentF.L_TOPRIGHT:SetTexture("");
	yuanchengCFrame.TalentF.L_BOTTOMLEFT:SetTexture("");
	yuanchengCFrame.TalentF.L_BOTTOMRIGHT:SetTexture("");
	--
	yuanchengCFrame.TalentF.C_TOPLEFT:SetTexture("");
	yuanchengCFrame.TalentF.C_TOPRIGHT:SetTexture("");
	yuanchengCFrame.TalentF.C_BOTTOMLEFT:SetTexture("");
	yuanchengCFrame.TalentF.C_BOTTOMRIGHT:SetTexture("");
	--
	yuanchengCFrame.TalentF.R_TOPLEFT:SetTexture("");
	yuanchengCFrame.TalentF.R_TOPRIGHT:SetTexture("");
	yuanchengCFrame.TalentF.R_BOTTOMLEFT:SetTexture("");
	yuanchengCFrame.TalentF.R_BOTTOMRIGHT:SetTexture("");
	for i=1,3 do
		_G["TalentFYIDIAN"..i]:SetText();
		for ii=1,PIGtianfuhangshu do
			for iii=1,4 do
				_G["tianfuBUT_"..i.."_"..ii.."_"..iii]:Hide();
			end
		end
	end
	yuanchengCFrame.ZBLsit:Hide()
	yuanchengCFrame.ZBLsit_C:Hide()
	yuanchengCFrame:Show()
end
local function GetDATA_YN()
	CZ_yuanchengCData(INVTYPE_RANGED)
	--没有获取到目标信息
	if yuanchengCFrame.alaGet then yuanchengCFrame.alaGet:Cancel() end
	yuanchengCFrame.alaGet=C_Timer.NewTimer(0.8,alaGet_Fun)

	if yuanchengCFrame.ycNull then yuanchengCFrame.ycNull:Cancel() end
	yuanchengCFrame.ycNull=C_Timer.NewTimer(3,ycNull_Fun)
end
---
local function FasongYCqingqiu(fullnameX)
	if InspectFrame and InspectFrame:IsShown() then InspectFrame:Hide() end
	SendAddonMessage(biaotou,YCinfo_GET_MSG[1], "WHISPER", fullnameX)
	GetDATA_YN()
	yuanchengCFrame.TitleText:SetText(fullnameX);
	yuanchengCFrame.fullnameX=fullnameX
	yuanchengCFrame.unit="yc"
end
addonTable.FasongYCqingqiu=FasongYCqingqiu
local function lixian_chakan(fullnameX,renwu,itemdata)
	if InspectFrame and InspectFrame:IsShown() then InspectFrame:Hide() end
	CZ_yuanchengCData(FRIENDS_LIST_OFFLINE)
	yuanchengCFrame.TitleText:SetText(fullnameX);
	yuanchengCFrame.fullnameX=fullnameX
	--yuanchengCFrame.unit="lixian"
	yuanchengCFrame.ly="lixian"

	yuanchengCFrame.Data_Info[1]={["class"]=renwu[4],["race"]=renwu[2],["level"]=renwu[5]}
	Update_ShowPlayer()
	yuanchengCFrame.Data_Info[3]=itemdata["T"]
	Update_ShowTianfu()
	yuanchengCFrame.Data_Info[2]=itemdata["C"]
	Update_ShowItem()
end
addonTable.lixian_chakan=lixian_chakan
------------------------------------
local function SAVE_Player()
	local Info = ""
	local raceName, raceFile, raceID = UnitRace("player")
	local level = UnitLevel("player")
	local _, classId = UnitClassBase("player");
	Info = Info..classId.."-"..raceID.."-"..level
	return Info
end
local function PIGGetActiveTalentGroup()
	return 1
end
local GetActiveTalentGroup=GetActiveTalentGroup or PIGGetActiveTalentGroup
local function GetTianfuData()
	local DataInfo = ""
	local linshiTFinfo = {}
	for i=1,3 do
		linshiTFinfo[i]={}
		for ii=1,PIGtianfuhangshu do
			linshiTFinfo[i][ii]={}
			for iii=1,4 do
				linshiTFinfo[i][ii][iii]="null"
			end
		end
	end
	--local numGroup = GetNumTalentGroups(false, false) or 1
	local activeGroup = GetActiveTalentGroup(false, false)
	local numTabs = GetNumTalentTabs()
	for i=1,numTabs do
		local numTalents=GetNumTalents(i)
		for ii=1,numTalents do
			local name, iconTexture, tier, column, rank = GetTalentInfo(i, ii,false,false,activeGroup)
			linshiTFinfo[i][tier][column]=rank
		end
	end
	local linshiTFinfo1 = {}
	for i=1,3 do
		for ii=1,PIGtianfuhangshu do
			for iii=1,4 do
				if linshiTFinfo[i][ii][iii]~="null" then
					table.insert(linshiTFinfo1,linshiTFinfo[i][ii][iii])
				end
			end
		end
	end
	for i=1,#linshiTFinfo1 do
		DataInfo=DataInfo..linshiTFinfo1[i]
	end
	return DataInfo
end
addonTable.GetTianfuData=GetTianfuData
local function SAVE_Talent()
	local TFInfo = "@"
	if tocversion<40000 then
		local tfdata=GetTianfuData()
		local code1=ALA.EncodeTalentBlock(tfdata)
		TFInfo=TFInfo..code1
	elseif tocversion<100000 then
		 -- local currentSpec = GetSpecialization()
		 -- TFInfo=TFInfo..currentSpec.."-"
		 -- for i=1,MAX_TALENT_TIERS do
		 -- 	local tierAvailable, selectedTalent, tierUnlockLevel = GetTalentTierInfo(i, 1, false, "player")
		 -- 	if i==MAX_TALENT_TIERS then
		 -- 		TFInfo=TFInfo..selectedTalent
		 -- 	else
		 -- 		TFInfo=TFInfo..selectedTalent.."-"
		 -- 	end
		 -- end
	else
		-- local currentSpec = GetSpecialization()
		-- TFInfo=TFInfo..currentSpec.."-"
		-- local exportStream = ExportUtil.MakeExportDataStream();
		-- local configID = C_ClassTalents.GetActiveConfigID()
		-- local currentSpecID = currentSpec
		-- local configInfo = C_Traits.GetConfigInfo(configID)
		-- local treeInfo = C_Traits.GetTreeInfo(configInfo.ID,configInfo.treeIDs[1]);
		-- local treeHash = C_Traits.GetTreeHash(treeInfo.ID);
		-- local serializationVersion = C_Traits.GetLoadoutSerializationVersion()
		-- ClassTalentFrame.TalentsTab:WriteLoadoutHeader(exportStream, serializationVersion, currentSpecID, treeHash);
		-- ClassTalentFrame.TalentsTab:WriteLoadoutContent(exportStream, configID, treeInfo.ID);
		-- local tianinfo=exportStream:GetExportString() or ""

		-- TFInfo=TFInfo..tianinfo
	end
	return TFInfo
end
------------------
local fengeLEN = 240
local yuanchangchakanFFF = CreateFrame("Frame")
yuanchangchakanFFF:RegisterEvent("CHAT_MSG_ADDON")
yuanchangchakanFFF:SetScript("OnEvent",function(self, event, arg1, arg2, _, arg4, arg5,_,_,_,arg9)
	if arg1 == biaotou then
		if arg2==YCinfo_GET_MSG[1] then
			local info1 =SAVE_Player()
			local info2 =SAVE_Talent()
			local info3 =ALA.EncodeItemList()
			local NewMsg = info1..info2.."@"..info3
			local msglen = strlen(NewMsg)
			if msglen>fengeLEN then
				local fasongcishu = math.ceil(msglen/fengeLEN)
				for i=1,fasongcishu do
					local jiequK = (i-1)*fengeLEN+1
					local jiequJ = -1
					if i~=fasongcishu then
						jiequJ = i*fengeLEN
					end
					local NewMsg1 = NewMsg:sub(jiequK,jiequJ)
					SendAddonMessage(biaotou, "!P"..fasongcishu..NewMsg1, "WHISPER", arg5)
				end		
			else
				SendAddonMessage(biaotou, "!T"..NewMsg, "WHISPER", arg5)
			end
		elseif arg2==YCinfo_GET_MSG[2] then

		else
			if yuanchengCFrame:IsShown() and yuanchengCFrame.fullnameX==arg5 then
				local qianzhui = arg2:sub(1, 2)	
				if qianzhui == "!T" then
					yuanchengCFrame.fanhuiYN=true
					yuanchengCFrame.ly="pig"
					yuanchengCFrame.yc_msg=arg2:sub(3, -1);
					Pig_YC_data()
				elseif qianzhui == "!P" then
					yuanchengCFrame.fanhuiYN=true
					yuanchengCFrame.ly="pig"
					yuanchengCFrame.yc_msg=yuanchengCFrame.yc_msg..arg2:sub(4, -1);
					if self.ycJieshou then self.ycJieshou:Cancel() end
					self.ycJieshou=C_Timer.NewTimer(0.3,Pig_YC_data)
				end
			end
		end
	elseif arg1==ala_PREFIX then
		if yuanchengCFrame:IsShown() and yuanchengCFrame.fullnameX==arg5 then			
			local qianzhui = arg2:sub(1, 2)	
			if qianzhui == "!T" then
				yuanchengCFrame.fanhuiYN=true
				yuanchengCFrame.ly="ala"
				yuanchengCFrame.yc_msg=arg2
				Pig_YC_data()
			elseif qianzhui == "!P" then
				yuanchengCFrame.fanhuiYN=true
				yuanchengCFrame.ly="ala"
				yuanchengCFrame.yc_msg=yuanchengCFrame.yc_msg..arg2:sub(9, -1);
				if self.ycJieshou then self.ycJieshou:Cancel() end
				self.ycJieshou=C_Timer.NewTimer(0.6,Pig_YC_data)
			end
		end
	end
end)