local addonName, addonTable = ...;
local _, _, _, tocversion = GetBuildInfo()
local L =addonTable.locale
local gsub = _G.string.gsub
local match = _G.string.match
local InviteUnit=InviteUnit or C_PartyInfo and C_PartyInfo.InviteUnit
---------------------------
local Create=addonTable.Create
local PIGFrame=Create.PIGFrame
local PIGLine=Create.PIGLine
local PIGEnter=Create.PIGEnter
local PIGButton = Create.PIGButton
local PIGDownMenu=Create.PIGDownMenu
local PIGSlider = Create.PIGSlider
local PIGCheckbutton=Create.PIGCheckbutton
local PIGCheckbutton_R=Create.PIGCheckbutton_R
local PIGOptionsList=Create.PIGOptionsList
local PIGOptionsList_RF=Create.PIGOptionsList_RF
local PIGOptionsList_R=Create.PIGOptionsList_R
local PIGFontString=Create.PIGFontString
local PIGFontStringBG=Create.PIGFontStringBG
local PIGQuickBut=Create.PIGQuickBut
local PIGCloseBut=Create.PIGCloseBut
local PIGSetFont=Create.PIGSetFont
local Show_TabBut_R=Create.Show_TabBut_R
------------------
local InviteFun=addonTable.InviteFun
local cl_Name=addonTable.Data.cl_Name
local cl_Name_Role=addonTable.Data.cl_Name_Role
local WWHH = 24
local pig_YELL = PIGFrame(UIParent,{"CENTER",UIParent,"CENTER",0,0},{126,WWHH},"pig_YELL_UI");
pig_YELL:SetMovable(true)
pig_YELL:SetClampedToScreen(true)
pig_YELL:Hide()
function InviteFun.Yell()
	if PIGA["Tardis"]["Yell"]["ShowDesktopBut"] then pig_YELL:Show() end
	local GnName,GnUI,GnIcon,FrameLevel = InviteFun.GnName,InviteFun.GnUI,InviteFun.GnIcon,InviteFun.FrameLevel
	local InvF=_G[GnUI]
	local fujiF,fujiTabBut=PIGOptionsList_R(InvF.F,L["INVITE_ZUDUI"],80,"Bot")
	---
	fujiF.hanhuajiange=10
	local suijizifu ={",",".","!",";","，","。","！","；"};
	fujiF.PindaoList={}
	local blocklist ={L["CHAT_BENDIFANGWU"],L["CHAT_WORLDFANGWU"]};
	if GetLocale() == "zhCN" then
		table.insert(blocklist,"服务")
	elseif GetLocale() == "zhTW" then
		table.insert(blocklist,"服務")
	end
	local function huoqupindaoxulie()
		local chatpindaoList = {{SAY,"SAY"},{"|cffFF4040"..YELL.."|r","YELL"},{"|cff40FF40"..GUILD.."|r","GUILD"}}
		local channels = {GetChannelList()}
		for i = 1, #channels, 3 do
			local id, name, disabled = channels[i], channels[i+1], channels[i+2]
			local baohanguolvpindao=true
			for h=1,#blocklist do
				if blocklist[h]==name then
					baohanguolvpindao=false
					break
				end
			end
			if baohanguolvpindao then
				table.insert(chatpindaoList,{"|cffFFC0C0"..name.."|r","CHANNEL",id})
			end
		end
		fujiF.PindaoList=chatpindaoList
	end
	C_Timer.After(3,huoqupindaoxulie)
	local function Get_famsg()
		local famsg =PIGA["Tardis"]["Yell"]["Yell_NR"]
		if Pig_OptionsUI.autoInvite_shikong and PIGA["Tardis"]["Yell"]["jinzuCMD_inv"] then
			famsg=famsg..",回复"..PIGA["Tardis"]["Yell"]["jinzuCMD"].."进组"
		end
		return famsg
	end
	--=====================
	local Roles = {"TANK", "HEALER","DAMAGER"}
	local RolesXulie = {["TANK"]=1, ["HEALER"]=2,["DAMAGER"]=3}
	local Roles_List={{},{},{}};
	local zhizeIcon=addonTable.Data.zhizeIcon
	local zhiye_F_H,zhiye_but_H=100,20
	--提取职业职责信息
	local function tiquzhize(id)
		for i=1,#cl_Name do
			local zhize = cl_Name[i][2]
			for ii=1,#zhize do
				if Roles[id]==zhize[ii] then
					table.insert(Roles_List[id],{cl_Name[i][1],cl_Name[i][3]})
				end
			end
		end
	end
	tiquzhize(1)
	tiquzhize(2)
	tiquzhize(3)
	---
	local fubenMoshi ={10,15,20,25,40};
	local fubenMoshi_peizhi = {}
	if tocversion<20000 then
		local englishFaction = UnitFactionGroup("player")
		if englishFaction=="Alliance" then
			for id=1,#Roles_List do
				for ix=#Roles_List[id],1,-1 do
					if Roles_List[id][ix][1]=="SHAMAN" then
						table.remove(Roles_List[id],ix)
					end
				end
			end
			fubenMoshi_peizhi ={
				[10]={
					[1]={2},
					[2]={1,0,1},
					[3]={0,1,1,2,2},
				},
				[15]={
					[1]={2},
					[2]={1,1,1},
					[3]={2,2,2,2,2},
				},
				[20]={
					[1]={2},
					[2]={2,1,1},
					[3]={4,2,3,3,2},
				},
				[25]={
					[1]={1,1,1},
					[2]={2,2,2},
					[3]={1,5,2,3,4,1},
				},
				[40]={
					[1]={4},
					[2]={4,2,3},
					[3]={8,4,6,6,3},
				},
			}
		elseif englishFaction=="Horde" then
			for id=1,#Roles_List do
				for ix=#Roles_List[id],1,-1 do
					if Roles_List[id][ix][1]=="PALADIN" then
						table.remove(Roles_List[id],ix)
					end
				end
			end
			fubenMoshi_peizhi ={
				[10]={
					[1]={1,1},
					[2]={1,0,1},
					[3]={0,2,1,2,1},
				},
				[15]={
					[1]={2},
					[2]={1,1,1},
					[3]={2,2,2,2,2},
				},
				[20]={
					[1]={2},
					[2]={2,1,1},
					[3]={4,2,3,3,2},
				},
				[25]={
					[1]={2,1},
					[2]={2,2,2},
					[3]={1,5,2,3,4,1},
				},
				[40]={
					[1]={4},
					[2]={4,2,3},
					[3]={8,4,6,6,3},
				},
			}
		end
	else
		fubenMoshi_peizhi ={
			[10]={
				[1]={1,1},
				[2]={1,1,1},
				[3]={0,1,1,2,1},
			},
			[15]={
				[1]={1,1},
				[2]={1,1,1,1},
				[3]={1,1,2,2,1,2},
			},
			[20]={
				[1]={1,1},
				[2]={1,1,1,1},
				[3]={4,2,3,3,2},
			},
			[25]={
				[1]={1,1,1},
				[2]={2,1,1,1},
				[3]={1,5,3,3,4,1},
			},
			[40]={
				[1]={2,1,1},
				[2]={2,2,2,2},
				[3]={6,6,6,4,4,2},
			},
		}
	end
	---顶部设置===================
	fujiF.topF = PIGFrame(fujiF,{"TOPLEFT",fujiF,"TOPLEFT",4,-4});
	fujiF.topF:SetPoint("TOPRIGHT", fujiF, "TOPRIGHT", -4, -4);
	fujiF.topF:SetHeight(350)
	fujiF.topF:PIGSetBackdrop(0)
	----职业限制内容
	fujiF.topF.zhiyeXZ = PIGFrame(fujiF.topF);
	fujiF.topF.zhiyeXZ:SetAllPoints(fujiF.topF)
	fujiF.topF.zhiyeXZ:Hide()
	---
	local function ADD_Roles_Frame(xulie)
		local zhizeF=PIGFrame(fujiF.topF.zhiyeXZ,nil,nil,"zhize_F_"..xulie)
		zhizeF:SetHeight(zhiye_F_H)
		zhizeF:PIGSetBackdrop()
		if xulie==1 then
			zhizeF:SetPoint("TOPLEFT",fujiF.topF.zhiyeXZ,"TOPLEFT",4,-4);
			zhizeF:SetPoint("TOPRIGHT", fujiF.topF.zhiyeXZ, "TOPRIGHT", -4, 4);
		else
			zhizeF:SetPoint("TOPLEFT",_G["zhize_F_"..(xulie-1)],"BOTTOMLEFT",0,-6);
			zhizeF:SetPoint("TOPRIGHT",_G["zhize_F_"..(xulie-1)],"BOTTOMRIGHT",0,-6);
		end
		zhizeF.Tex = zhizeF:CreateTexture(nil, "BORDER");
		zhizeF.Tex:SetTexture("interface/lfgframe/ui-lfg-icon-roles.blp");
		zhizeF.Tex:SetTexCoord(zhizeIcon[xulie][1],zhizeIcon[xulie][2],zhizeIcon[xulie][3],zhizeIcon[xulie][4]);
		zhizeF.Tex:SetSize(zhiye_but_H*3,zhiye_but_H*3);
		zhizeF.Tex:SetPoint("LEFT", zhizeF, "LEFT", 10,0);
		--
		zhizeF.mubiaoAll = PIGFontString(zhizeF,{"LEFT", zhizeF, "LEFT", 70,8},"目标人数", "OUTLINE");
		zhizeF.mubiaoAll_V = PIGFontString(zhizeF,{"LEFT", zhizeF.mubiaoAll, "RIGHT", 2,0},0, "OUTLINE");
		zhizeF.mubiaoAll_V:SetTextColor(1,1,1,1);
		zhizeF.dangqianAll = PIGFontString(zhizeF,{"LEFT", zhizeF, "LEFT", 70,-16},"已组人数", "OUTLINE");
		zhizeF.dangqianAll_V = PIGFontString(zhizeF,{"LEFT", zhizeF.dangqianAll, "RIGHT", 2,0},0, "OUTLINE");
		zhizeF.dangqianAll_V:SetTextColor(1,1,1,1);
		
		for id=1,#Roles_List[xulie] do
			local EditBox = CreateFrame("EditBox", "zhize_mubiao_E"..xulie.."_"..id, zhizeF, "InputBoxInstructionsTemplate");
			EditBox:SetSize(zhiye_but_H+4,zhiye_but_H);
			if id==1 then
				EditBox:SetPoint("LEFT", zhizeF.mubiaoAll, "LEFT", 110,0);
			else
				EditBox:SetPoint("LEFT",_G["zhize_mubiao_E"..xulie.."_"..(id-1)],"RIGHT",30,0);
			end
			PIGSetFont(EditBox,14,"OUTLINE")
			EditBox:SetJustifyH("CENTER")
			EditBox:SetNumeric(true)
			EditBox:SetMaxLetters(2)
			EditBox:SetAutoFocus(false)
			EditBox:SetTextColor(0.6, 0.6, 0.6, 0.94)
			EditBox:SetScript("OnEditFocusLost", function(self)
				self:SetTextColor(0.6, 0.6, 0.6, 0.94)
			end);
			EditBox:SetScript("OnEditFocusGained", function(self) 
				self:SetTextColor(1, 1, 1, 1)
			end)
			EditBox:SetScript("OnEscapePressed", function(self) 
				self:ClearFocus() 
			end);
			EditBox:SetScript("OnEnterPressed", function(self) 
				self:ClearFocus() 
				PIGA["Tardis"]["Yell"]["mubiaoNum"][xulie][id]=self:GetNumber();
				fujiF.topF.zhiyeXZ.GetRaidMubiao()
			end);
			EditBox.Icon=PIGFrame(EditBox,{"BOTTOM", EditBox, "TOP", -1,4},{zhiye_but_H+2,zhiye_but_H+2})
			EditBox.Icon.tex = EditBox.Icon:CreateTexture();
			EditBox.Icon.tex:SetTexture("Interface/TargetingFrame/UI-Classes-Circles");
			EditBox.Icon.tex:SetAllPoints(EditBox.Icon)
			local coords = CLASS_ICON_TCOORDS[Roles_List[xulie][id][1]]
			EditBox.Icon.tex:SetTexCoord(unpack(coords));
			-- EditBox.Icon:SetScript("OnMouseUp", function(self)
			-- 	if fujiF.topF.zhiyeXZ.xiugaiRF:IsShown() then
			-- 		fujiF.topF.zhiyeXZ.xiugaiRF:Hide()
			-- 	else
			-- 		fujiF.topF.zhiyeXZ.xiugaiRF:Show()
			-- 		xianshixiugaiUI(EditBox.Icon,xulie,id)
			-- 	end
			-- end)

			EditBox.yizu = PIGFontString(EditBox,{"TOP", EditBox, "BOTTOM", -1,-8},nil,"OUTLINE");
			EditBox.wancheng = EditBox:CreateTexture();
			EditBox.wancheng:SetSize(zhiye_but_H,zhiye_but_H-4);
			EditBox.wancheng:SetPoint("TOP", EditBox.yizu, "BOTTOM", 0,-6);
		end
	end
	ADD_Roles_Frame(1)
	ADD_Roles_Frame(2)
	ADD_Roles_Frame(3)
	---
	-- fujiF.xiugaiRF=PIGFrame(fujiF,nil,{260,300})
	-- fujiF.xiugaiRF:PIGSetBackdrop(1)
	-- fujiF.xiugaiRF:PIGClose()
	-- fujiF.xiugaiRF:Hide()
	-- fujiF.xiugaiRF:SetFrameLevel(fujiF.xiugaiRF:GetFrameLevel()+10)
	-- fujiF.xiugaiRF.biaoti = PIGFontString(fujiF.xiugaiRF,{"TOP", fujiF.xiugaiRF, "TOP", 0,-3},"", "OUTLINE");
	-- local shezhiWH = 24
	-- for i=1,MAX_RAID_MEMBERS do
	-- 	local pbut = CreateFrame("Button","Zuidui_xigairzhizeUI_"..i,fujiF.xiugaiRF)
	-- 	pbut:SetSize(shezhiWH,shezhiWH);
	-- 	if i==1 then
	-- 		pbut:SetPoint("TOPLEFT", fujiF.xiugaiRF, "TOPLEFT", 10,-24);
	-- 	elseif i==21 then
	-- 		pbut:SetPoint("TOPLEFT", fujiF.xiugaiRF, "TOPLEFT", 290,-24);
	-- 	else
	-- 		pbut:SetPoint("TOP",_G["Zuidui_xigairzhizeUI_"..(i-1)],"BOTTOM",0,-3);
	-- 	end
	-- 	pbut.Tex = pbut:CreateTexture();
	-- 	pbut.Tex:SetTexture("interface/lfgframe/ui-lfg-icon-roles.blp");
	-- 	pbut.Tex:SetTexCoord(zhizeIcon[1][1],zhizeIcon[1][2],zhizeIcon[1][3],zhizeIcon[1][4]);
	-- 	pbut.Tex:SetSize(shezhiWH,shezhiWH);
	-- 	pbut.Tex:SetPoint("CENTER", pbut, "CENTER", 0,0);
	-- 	pbut:SetScript("OnMouseDown", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut, "CENTER", 1.5,-1.5);
	-- 	end);
	-- 	pbut:SetScript("OnMouseUp", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut, "CENTER", 0,0);
	-- 	end);
	-- 	pbut:HookScript("OnClick", function (self)
	-- 		local wanjname = self.name:GetText()
	-- 		for p=1,MAX_RAID_MEMBERS do
	-- 			local name = GetRaidRosterInfo(p);
	-- 			if name then
	-- 				if name==wanjname then
	-- 					UnitSetRole(riad..p, "TANK")--"NONE"
	-- 					break
	-- 				end
	-- 			end
	-- 		end
	-- 		fujiF.xiugaiRF:Hide()
	-- 	end);
	-- 	pbut.zhize2 = CreateFrame("Button",nil,pbut)
	-- 	pbut.zhize2:SetSize(shezhiWH,shezhiWH);
	-- 	pbut.zhize2:SetPoint("LEFT", pbut, "RIGHT", 4,0);
	-- 	pbut.zhize2.Tex = pbut.zhize2:CreateTexture();
	-- 	pbut.zhize2.Tex:SetTexture("interface/lfgframe/ui-lfg-icon-roles.blp");
	-- 	pbut.zhize2.Tex:SetTexCoord(zhizeIcon[2][1],zhizeIcon[2][2],zhizeIcon[2][3],zhizeIcon[2][4]);
	-- 	pbut.zhize2.Tex:SetSize(shezhiWH,shezhiWH);
	-- 	pbut.zhize2.Tex:SetPoint("CENTER", pbut.zhize2, "CENTER", 0,0);
	-- 	pbut.zhize2:SetScript("OnMouseDown", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut.zhize2, "CENTER", 1.5,-1.5);
	-- 	end);
	-- 	pbut.zhize2:SetScript("OnMouseUp", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut.zhize2, "CENTER", 0,0);
	-- 	end);
	-- 	pbut.zhize2:HookScript("OnClick", function (self)
	-- 		local fujiku = self:GetParent()
	-- 		local wanjname = fujiku.name:GetText()
	-- 		for p=1,MAX_RAID_MEMBERS do
	-- 			local name = GetRaidRosterInfo(p);
	-- 			if name then
	-- 				if name==wanjname then
	-- 					UnitSetRole(riad..p, "HEALER")
	-- 					break
	-- 				end
	-- 			end
	-- 		end
	-- 		fujiF.xiugaiRF:Hide()
	-- 	end);
	-- 	pbut.zhize3 = CreateFrame("Button",nil,pbut)
	-- 	pbut.zhize3:SetSize(shezhiWH,shezhiWH);
	-- 	pbut.zhize3:SetPoint("LEFT", pbut.zhize2, "RIGHT", 4,0);
	-- 	pbut.zhize3.Tex = pbut.zhize3:CreateTexture();
	-- 	pbut.zhize3.Tex:SetTexture("interface/lfgframe/ui-lfg-icon-roles.blp");
	-- 	pbut.zhize3.Tex:SetTexCoord(zhizeIcon[3][1],zhizeIcon[3][2],zhizeIcon[3][3],zhizeIcon[3][4]);
	-- 	pbut.zhize3.Tex:SetSize(shezhiWH,shezhiWH);
	-- 	pbut.zhize3.Tex:SetPoint("CENTER", pbut.zhize3, "CENTER", 0,0);
	-- 	pbut.zhize3:SetScript("OnMouseDown", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut.zhize3, "CENTER", 1.5,-1.5);
	-- 	end);
	-- 	pbut.zhize3:SetScript("OnMouseUp", function (self)
	-- 		self.Tex:SetPoint("CENTER", pbut.zhize3, "CENTER", 0,0);
	-- 	end);
	-- 	pbut.zhize3:HookScript("OnClick", function (self)
	-- 		local fujiku = self:GetParent()
	-- 		local wanjname = fujiku.name:GetText()
	-- 		for p=1,MAX_RAID_MEMBERS do
	-- 			local name = GetRaidRosterInfo(p);
	-- 			if name then
	-- 				if name==wanjname then
	-- 					UnitSetRole(riad..p, "DAMAGER")
	-- 					break
	-- 				end
	-- 			end
	-- 		end
	-- 		fujiF.xiugaiRF:Hide()
	-- 	end);
	-- 	pbut.name = PIGFontString(pbut,{"LEFT", pbut.zhize3, "RIGHT", 4,0},"", "OUTLINE");
	-- end
	-- local function xianshixiugaiUI(self,rid,ZID)
	-- 	fujiF.xiugaiRF:SetPoint("TOP", self, "BOTTOM", 0,-4);
	-- 	fujiF.xiugaiRF.biaoti:SetText(_G[Roles[rid]].."-"..Roles_List[rid][ZID][2])
	-- 	for p=1,MAX_RAID_MEMBERS do
	-- 		local xuanzeli = _G["Zuidui_xigairzhizeUI_"..p]
	-- 		xuanzeli:Hide()
	-- 		if fujiF.Datas_DQList[p] then
	-- 			if fujiF.Datas_DQList[p][3]==Roles[rid] then
	-- 				xuanzeli:Show()
	-- 				xuanzeli.name:SetText(fujiF.Datas_DQList[p][1])
	-- 			end
	-- 		end
	-- 	end
	-- end

	--载入默认人数配置
	fujiF.topF.zhiyeXZ.daoruMoren=PIGDownMenu(fujiF.topF.zhiyeXZ,{"BOTTOMLEFT",fujiF.topF.zhiyeXZ,"BOTTOMLEFT", 4,5},{124,24})
	fujiF.topF.zhiyeXZ.daoruMoren:PIGDownMenu_SetText("导入预设人数")
	function fujiF.topF.zhiyeXZ.daoruMoren:PIGDownMenu_Update_But(self)
		local info = {}
		info.func = self.PIGDownMenu_SetValue
		for i=1,#fubenMoshi,1 do
		    info.text, info.arg1 = "导入"..fubenMoshi[i].."人预设人数", fubenMoshi[i]
		    info.notCheckable = true;
			fujiF.topF.zhiyeXZ.daoruMoren:PIGDownMenu_AddButton(info)
		end 
	end
	function fujiF.topF.zhiyeXZ.daoruMoren:PIGDownMenu_SetValue(value,arg1)
		PIGA["Tardis"]["Yell"]["mubiaoNum"]=fubenMoshi_peizhi[arg1]
		PIGinfotip:TryDisplayMessage("已导入|cffFFFFFF"..arg1.."|r人预设人数");
		PIGCloseDropDownMenus()
		fujiF.topF.zhiyeXZ.GetRaidMubiao()
	end
	---转换团队/小队
	fujiF.topF.zhiyeXZ.zhuanhuanPR=PIGButton(fujiF.topF.zhiyeXZ,{"LEFT",fujiF.topF.zhiyeXZ.daoruMoren,"RIGHT", 30,0},{120,20},"转换团队/小队")
	fujiF.topF.zhiyeXZ.zhuanhuanPR:SetScript("OnClick", function (self)
		if IsInRaid("LE_PARTY_CATEGORY_HOME") then
			--C_PartyInfo.ConvertToParty() 
			ConvertToParty() 
		elseif IsInGroup("LE_PARTY_CATEGORY_HOME") then
			--C_PartyInfo.ConvertToRaid()
			ConvertToRaid()
		end
	end)
	---职责确认
	fujiF.topF.zhiyeXZ.RolesJC=PIGButton(fujiF.topF.zhiyeXZ,{"LEFT",fujiF.topF.zhiyeXZ.zhuanhuanPR,"RIGHT", 30,0},{100,20},"职责确认")
	fujiF.topF.zhiyeXZ.RolesJC:SetScript("OnClick", function (self)
		LFGListingRolePollButton_OnClick(self, button)
	end)
	---就位确认
	fujiF.topF.zhiyeXZ.jiuwei=PIGButton(fujiF.topF.zhiyeXZ,{"LEFT",fujiF.topF.zhiyeXZ.RolesJC,"RIGHT", 30,0},{100,20},"就位确认")
	fujiF.topF.zhiyeXZ.jiuwei:SetScript("OnClick", function (self)
		DoReadyCheck()
	end)
	---刷新
	fujiF.topF.zhiyeXZ.shuaxinP=PIGButton(fujiF.topF.zhiyeXZ,{"LEFT",fujiF.topF.zhiyeXZ.jiuwei,"RIGHT", 30,0},{120,20},"刷新成员信息")
	fujiF.topF.zhiyeXZ.shuaxinP:SetScript("OnClick", function (self)
		fujiF.topF.zhiyeXZ.GetRaidPlayers()
	end)
	--获取目标人数
	function fujiF.topF.zhiyeXZ.GetRaidMubiao()
		fujiF.Datas_MB={
			["All"]=0,
			["Xulie"]={0,0,0},
			["Xulie_MB"]={{},{},{}},
		};
		local renyuanD = PIGA["Tardis"]["Yell"]["mubiaoNum"]
		for xulie=1,#Roles_List do
			for id=1,#Roles_List[xulie] do
				local mubiaoS = renyuanD[xulie][id] or 0
				fujiF.Datas_MB.All=fujiF.Datas_MB.All+mubiaoS
				fujiF.Datas_MB.Xulie[xulie]=fujiF.Datas_MB.Xulie[xulie]+mubiaoS
				local ZhiyeS = fujiF.Datas_MB.Xulie_MB[xulie][id] or 0
				fujiF.Datas_MB.Xulie_MB[xulie][id]=ZhiyeS+mubiaoS
			end
		end
		fujiF.botF_R.XZ_playerNum.E:SetText(fujiF.Datas_MB.All)
		fujiF.botF_R.DQ_playerNumV_max:SetText(fujiF.Datas_MB.All)
		PIGA["Tardis"]["Yell"]["XZ_playerNumV"]=fujiF.Datas_MB.All
		fujiF.topF.zhiyeXZ.ShowPlayersList()
	end
	--获取当前人员
	fujiF.Datas_DQList={}
	function fujiF.topF.zhiyeXZ.GetRaidPlayers()
		local NewZhiyeData={};
		local numGroupMembers = GetNumGroupMembers("LE_PARTY_CATEGORY_HOME")
		if numGroupMembers>0 then
			for p=1,MAX_RAID_MEMBERS do
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML, combatRole = GetRaidRosterInfo(p);
				if name then
					--print(name,fileName,combatRole)
					NewZhiyeData[name]={fileName,combatRole}
				end
			end
		end
		---如果没有职责信息根据玩家回复设置
		-- for x=1,#NewZhiyeData do
		-- 	for p=1,#fujiF.Datas_DQList do		
		-- 		if NewZhiyeData[x][1]==fujiF.Datas_DQList[p][1] then
		-- 			--NewZhiyeData[x][3]=fujiF.Datas_DQ[p][3]
		-- 		end
		-- 	end
		-- end
		-- fujiF.Datas_DQList=NewZhiyeData;
		fujiF.Datas_DQ={
			["All"]=0,
			["Xulie"]={0,0,0},
			["Xulie_MB"]={{},{},{}},
		};
		local renyuanNew = NewZhiyeData
		for xulie=1,#Roles_List do
			for id=1,#Roles_List[xulie] do
				fujiF.Datas_DQ.Xulie_MB[xulie][id]=fujiF.Datas_DQ.Xulie_MB[xulie][id] or 0
				for k,v in pairs(renyuanNew) do
					fujiF.Datas_DQ.All=fujiF.Datas_DQ.All+1
					if v[1]==Roles_List[xulie][id][1] then
						if v[2]==Roles[xulie] then
							fujiF.Datas_DQ.Xulie[xulie]=fujiF.Datas_DQ.Xulie[xulie]+1
							fujiF.Datas_DQ.Xulie_MB[xulie][id]=fujiF.Datas_DQ.Xulie_MB[xulie][id]+1
						end
					end
				end
			end
		end
		fujiF.topF.zhiyeXZ.ShowPlayersList()
	end
	--显示更新
	function fujiF.topF.zhiyeXZ.ShowPlayersList()
		if not fujiF.topF.zhiyeXZ:IsVisible() then return end
		local renyuanD = fujiF.Datas_MB
		for xulie=1,#Roles_List do
			for id=1,#Roles_List[xulie] do
				_G["zhize_mubiao_E"..xulie.."_"..id]:SetText(fujiF.Datas_MB.Xulie_MB[xulie][id])
			end
			_G["zhize_F_"..xulie].mubiaoAll_V:SetText(fujiF.Datas_MB.Xulie[xulie])
		end
		for xulie=1,#Roles_List do
			for id=1,#Roles_List[xulie] do
				local fujiku = _G["zhize_mubiao_E"..xulie.."_"..id]
				fujiku.wancheng:Hide()
				if fujiF.Datas_DQ.Xulie_MB[xulie][id]==fujiF.Datas_MB.Xulie_MB[xulie][id] then
					fujiku.wancheng:Show()
					fujiku.wancheng:SetTexture("interface/raidframe/readycheck-ready.blp");
				elseif fujiF.Datas_DQ.Xulie_MB[xulie][id]>fujiF.Datas_MB.Xulie_MB[xulie][id] then
					fujiku.wancheng:Show()
					fujiku.wancheng:SetTexture("interface/raidframe/readycheck-notready.blp");--X号
				end
				fujiku.yizu:SetText(fujiF.Datas_DQ.Xulie_MB[xulie][id])
			end
			_G["zhize_F_"..xulie].dangqianAll_V:SetText(fujiF.Datas_DQ.Xulie[xulie])
		end
	end
	fujiF.topF.zhiyeXZ:HookScript("OnShow", function(self)
		self.ShowPlayersList()
	end);
	----职业限制内容
	fujiF.topF.autoHF = PIGFrame(fujiF.topF);
	fujiF.topF.autoHF:SetAllPoints(fujiF.topF)
	fujiF.topF.autoHF:Hide()
	fujiF.topF.autoHF.err = PIGFontString(fujiF.topF.autoHF,{"CENTER",fujiF.topF.autoHF,"CENTER",0,0},"正在施工...");
	---底部设置===================
	fujiF.botF_L = PIGFrame(fujiF,{"TOPLEFT",fujiF.topF,"BOTTOMLEFT",0,-4});
	fujiF.botF_L:SetPoint("BOTTOMLEFT", fujiF, "BOTTOMLEFT", 4, 4);
	fujiF.botF_L:SetWidth(520)
	fujiF.botF_L:PIGSetBackdrop(0)
	--喊话内容
	fujiF.botF_L.Yell_NR = PIGFrame(fujiF.botF_L,{"TOPLEFT", fujiF.botF_L, "TOPLEFT", 4,-22});
	fujiF.botF_L.Yell_NR:SetPoint("BOTTOMRIGHT", fujiF.botF_L, "BOTTOMRIGHT", -140, 4);
	fujiF.botF_L.Yell_NR:PIGSetBackdrop()
	fujiF.botF_L.Yell_NR.biaoti = PIGFontString(fujiF.botF_L.Yell_NR,{"BOTTOMLEFT", fujiF.botF_L.Yell_NR, "TOPLEFT", 2,4},"喊话内容");
	fujiF.botF_L.Yell_NR.zifulen = PIGFontString(fujiF.botF_L.Yell_NR,{"BOTTOMLEFT", fujiF.botF_L.Yell_NR.biaoti, "BOTTOMRIGHT", 0,0},"(当前字符数",nil,12);
	fujiF.botF_L.Yell_NR.zifulen:SetTextColor(0, 1, 1, 1);
	fujiF.botF_L.Yell_NR.zifulenV = PIGFontString(fujiF.botF_L.Yell_NR,{"LEFT", fujiF.botF_L.Yell_NR.zifulen, "RIGHT", 0,0},0,nil,12);
	fujiF.botF_L.Yell_NR.zifulenV:SetTextColor(0, 1, 0, 1);
	fujiF.botF_L.Yell_NR.zifulenend = PIGFontString(fujiF.botF_L.Yell_NR,{"LEFT", fujiF.botF_L.Yell_NR.zifulenV, "RIGHT", 0,0},"/250):",nil,12);
	fujiF.botF_L.Yell_NR.zifulenend:SetTextColor(0, 1, 1, 1);
	fujiF.botF_L.Yell_NR.E = CreateFrame("EditBox", nil, fujiF.botF_L.Yell_NR);
	fujiF.botF_L.Yell_NR.E:SetPoint("TOPLEFT", fujiF.botF_L.Yell_NR, "TOPLEFT", 2,-2);
	fujiF.botF_L.Yell_NR.E:SetPoint("BOTTOMRIGHT", fujiF.botF_L.Yell_NR, "BOTTOMRIGHT", -2,2);
	fujiF.botF_L.Yell_NR.E:SetFontObject(ChatFontNormal);
	fujiF.botF_L.Yell_NR.E:SetAutoFocus(false);
	fujiF.botF_L.Yell_NR.E:SetMultiLine(true)
	fujiF.botF_L.Yell_NR.E:SetMaxLetters(200);
	fujiF.botF_L.Yell_NR.E:SetTextColor(0.7, 0.7, 0.7, 1);
	fujiF.botF_L.Yell_NR.E:SetScript("OnEditFocusGained", function(self) 
		self:SetTextColor(1, 1, 1, 1);
	end);
	fujiF.botF_L.Yell_NR.E:SetScript("OnEditFocusLost", function(self)
		self:SetTextColor(0.7, 0.7, 0.7, 1);
		self:SetText(PIGA["Tardis"]["Yell"]["Yell_NR"])
	end);
	fujiF.botF_L.Yell_NR.E:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus()
	end);
	fujiF.botF_L.Yell_NR.E:SetScript("OnEnterPressed", function(self) 
		PIGA["Tardis"]["Yell"]["Yell_NR"]=self:GetText();
		fujiF.Updata_Macro()
		self:ClearFocus()
	end);
	local function panduanzifushuOK(self)
		local famsg =Get_famsg()
		local msglen = strlen(famsg)
		if msglen>250 then
			fujiF.botF_L.Yell_NR.zifulenV:SetText(msglen.."超过最大字符限制")
			fujiF.botF_L.Yell_NR.zifulenV:SetTextColor(1, 0, 0, 1);
		else
			fujiF.botF_L.Yell_NR.zifulenV:SetText(msglen)
			fujiF.botF_L.Yell_NR.zifulenV:SetTextColor(1, 1, 0, 1);
		end
	end
	fujiF.botF_L.Yell_NR.E:SetScript("OnCursorChanged", function(self)
		panduanzifushuOK(self)
	end);
	--喊话模板
	fujiF.botF_L.Yell_NR.changyong = PIGButton(fujiF.botF_L.Yell_NR,{"BOTTOMRIGHT",fujiF.botF_L.Yell_NR,"TOPRIGHT",-4,1},{70,18},"喊话模板",nil,nil,nil,12);
	fujiF.botF_L.Yell_NR.changyong:Disable()
	--喊话频道==========
	fujiF.botF_L.Yell_CHANNEL=PIGDownMenu(fujiF.botF_L,{"TOPLEFT",fujiF.botF_L.Yell_NR,"TOPRIGHT",8,-0},{100,24})
	fujiF.botF_L.Yell_CHANNEL:PIGDownMenu_SetText(CHOOSE..CHANNEL)
	function fujiF.botF_L.Yell_CHANNEL:PIGDownMenu_Update_But(self)
		huoqupindaoxulie()
		local PindaoList=fujiF.PindaoList
		local info = {}
		info.func = self.PIGDownMenu_SetValue
		for i=1,#PindaoList,1 do
		    info.text, info.arg1 = PindaoList[i][1], PindaoList[i][2]
		    info.checked = PIGA["Tardis"]["Yell"]["Yell_CHANNEL"][PindaoList[i][1]]
		    info.isNotRadio=true
			fujiF.botF_L.Yell_CHANNEL:PIGDownMenu_AddButton(info)
		end 
	end
	function fujiF.botF_L.Yell_CHANNEL:PIGDownMenu_SetValue(value,arg1,arg2,checked)
		PIGA["Tardis"]["Yell"]["Yell_CHANNEL"][value]=checked
		fujiF.Updata_Macro()
		PIGCloseDropDownMenus()
	end
	------喊话宏
	local suijizuoqi = "/s "..PIGA["Tardis"]["Yell"]["Yell_NR"]
	local YELL_BUT_HONG = CreateFrame("Button","YELL_BUT_HONG",UIParent, "SecureActionButtonTemplate,ActionButtonTemplate");
	YELL_BUT_HONG:SetAttribute("type", "macro")
	YELL_BUT_HONG:SetAttribute("macrotext", suijizuoqi)
	-- YELL_BUT_HONG:SetPoint("CENTER",UIParent,"CENTER",0,0);
	-- YELL_BUT_HONG:SetSize(50,50);
	local hanhuaHongName = {"PIGyell",NEW.."喊话"..MACRO,UPDATE.."喊话"..MACRO}
	fujiF.botF_L.Yell_hong = PIGButton(fujiF.botF_L,{"TOPLEFT",fujiF.botF_L.Yell_CHANNEL,"BOTTOMLEFT",0,-10},{100,24},hanhuaHongName[2]); 
	PIGEnter(fujiF.botF_L.Yell_hong,"非战斗状态任何修改插件会自动更新喊话宏,\n如果战斗中更改过喊话内容或者其他选项请手动更新喊话宏")
	fujiF.botF_L.Yell_hong:HookScript("OnShow", function (self)
		local macroSlot = GetMacroIndexByName(hanhuaHongName[1])
		if macroSlot>0 then
			self:SetText(hanhuaHongName[3]);
		else
			self:SetText(hanhuaHongName[2]);
		end
	end)
	fujiF.botF_L.Yell_hong:SetScript("OnClick", function (self)
		local macroSlot = GetMacroIndexByName(hanhuaHongName[1])
		if macroSlot>0 then
			fujiF.Updata_Macro()
		else
			local global = GetNumMacros()
			if global<120 then
				StaticPopup_Show ("CHUANGJIANHONGPIG");
			else
				PIGinfotip:TryDisplayMessage(L["LIB_MACROERR"]);
			end
		end
	end)
	StaticPopupDialogs["CHUANGJIANHONGPIG"] = {
		text = "将创建一个名为<"..hanhuaHongName[1]..">喊话宏\n请拖拽到动作条使用\n确定创建吗？\n\n",
		button1 = OKAY,
		button2 = CANCEL,
		OnAccept = function()
			fujiF.Updata_Macro("add")
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
	}
	local function gengxinhongtxt()
		huoqupindaoxulie()
		local PindaoList=fujiF.PindaoList
		local yellpindaolist = {}
		for i=1,#PindaoList do
			if PIGA["Tardis"]["Yell"]["Yell_CHANNEL"][PindaoList[i][1]] then
				table.insert(yellpindaolist,{PindaoList[i][2],PindaoList[i][3]})
			end
		end
		local keyongshu = #yellpindaolist
		local hanhuabuthongNR=""
		if keyongshu>0 then
			local famsg =Get_famsg()
			for x=1,#yellpindaolist do
				local suijishu=random(1, 8)
				local  famsg= famsg..suijizifu[suijishu]
				if yellpindaolist[x][1]=="CHANNEL" then
					hanhuabuthongNR=hanhuabuthongNR.."/"..yellpindaolist[x][2].." "..famsg.."\r"
				else
					hanhuabuthongNR=hanhuabuthongNR.."/"..yellpindaolist[x][1].." "..famsg.."\r"
				end
			end
		end
		--print(hanhuabuthongNR)
		YELL_BUT_HONG:SetAttribute("macrotext", hanhuabuthongNR)
	end
	gengxinhongtxt()
	function fujiF.Updata_Macro(add)
		if InCombatLockdown() then PIGinfotip:TryDisplayMessage("请战斗结束后手动更新喊话宏",1,0,0) return end
		if add=="add" then
			CreateMacro(hanhuaHongName[1], 135451, "/click YELL_BUT_HONG", nil)
			gengxinhongtxt()
			PIGinfotip:TryDisplayMessage("已创建喊话宏")
			fujiF.Yell_hong:SetText(hanhuaHongName[3]);
		else
			local macroSlot = GetMacroIndexByName(hanhuaHongName[1])
			if macroSlot>0 then
				--print(GetMacroInfo(macroSlot))
				EditMacro(macroSlot, nil, 135451, "/click YELL_BUT_HONG")
				gengxinhongtxt()
				if add~="OPEN" then
					PIGinfotip:TryDisplayMessage("已更新喊话宏")
				end
			end
		end
	end
	--喊话按钮
	fujiF.botF_L.Yell_NR.yellbut = PIGButton(fujiF.botF_L.Yell_NR,{"TOPLEFT",fujiF.botF_L.Yell_hong,"BOTTOMLEFT",0,-10},{100,24},"喊话");
	fujiF.botF_L.Yell_NR.yellbut:SetScript("OnClick", function (self)
		fujiF.Kaishi_Yell()
	end);
	fujiF.botF_L:HookScript("OnShow", function(self)
		self.Yell_NR.E:SetText(PIGA["Tardis"]["Yell"]["Yell_NR"])
	end);

	--=邀请条件====================
	fujiF.botF_R = PIGFrame(fujiF,{"TOPLEFT",fujiF.botF_L,"TOPRIGHT",4,0});
	fujiF.botF_R:SetPoint("BOTTOMRIGHT", fujiF, "BOTTOMRIGHT", -4, 4);
	fujiF.botF_R:PIGSetBackdrop(0)
	--人数限制
	fujiF.botF_R.XZ_playerNum = PIGCheckbutton(fujiF.botF_R,{"TOPLEFT",fujiF.botF_R,"TOPLEFT",10,-6},{"限制人数","当启用人数限制，到达指定人数后将自动关闭自动邀请"})
	fujiF.botF_R.XZ_playerNum:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Tardis"]["Yell"]["XZ_playerNum"]=true;
		else
			PIGA["Tardis"]["Yell"]["XZ_playerNum"]=false;
		end
	end);
	fujiF.botF_R.XZ_playerNum.E = CreateFrame("EditBox", nil, fujiF.botF_R.XZ_playerNum,"InputBoxInstructionsTemplate");
	fujiF.botF_R.XZ_playerNum.E:SetSize(40,26);
	fujiF.botF_R.XZ_playerNum.E:SetPoint("LEFT",fujiF.botF_R.XZ_playerNum.Text,"RIGHT",6,0);
	fujiF.botF_R.XZ_playerNum.E:SetFontObject(ChatFontNormal);
	fujiF.botF_R.XZ_playerNum.E:SetMaxLetters(2)
	fujiF.botF_R.XZ_playerNum.E:SetAutoFocus(false);
	fujiF.botF_R.XZ_playerNum.E:SetNumeric(true)
	fujiF.botF_R.XZ_playerNum.E:SetTextColor(0.7, 0.7, 0.7, 1);
	PIGEnter(fujiF.botF_R.XZ_playerNum.E,"开启《根据职业职责邀请》时根据设置职业人数自动设置限制人数")
	fujiF.botF_R.XZ_playerNum.E:SetScript("OnEditFocusGained", function(self) 
		self:SetTextColor(1, 1, 1, 1);
	end);
	fujiF.botF_R.XZ_playerNum.E:SetScript("OnEditFocusLost", function(self)
		self:SetTextColor(0.7, 0.7, 0.7, 1);
		self:SetText(PIGA["Tardis"]["Yell"]["XZ_playerNumV"])
	end);
	fujiF.botF_R.XZ_playerNum.E:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus()
	end);
	fujiF.botF_R.XZ_playerNum.E:SetScript("OnEnterPressed", function(self) 
		PIGA["Tardis"]["Yell"]["XZ_playerNumV"]=self:GetNumber();
		fujiF.botF_R.DQ_playerNumV_max:SetText(PIGA["Tardis"]["Yell"]["XZ_playerNumV"])
		self:ClearFocus()
	end);
	--根据指令邀请
	fujiF.botF_R.jinzuCMD_inv = PIGCheckbutton(fujiF.botF_R,{"LEFT",fujiF.botF_R.XZ_playerNum,"RIGHT",130,0},{"邀请指令","在开启《自动邀请》情况下喊话内容自动附加邀请指令，玩家回复指令将直接进组(开启判断职业职责以后不会直接进组)"})
	fujiF.botF_R.jinzuCMD_inv:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Tardis"]["Yell"]["jinzuCMD_inv"]=true;
		else
			PIGA["Tardis"]["Yell"]["jinzuCMD_inv"]=false;
		end
		panduanzifushuOK(fujiF.botF_L.Yell_NR.E)
		fujiF.Updata_Macro()
	end);
	--进组指令
	fujiF.botF_R.jinzuCMD_inv.E = CreateFrame("EditBox", nil, fujiF.botF_R.jinzuCMD_inv,"InputBoxInstructionsTemplate");
	fujiF.botF_R.jinzuCMD_inv.E:SetSize(60,26);
	fujiF.botF_R.jinzuCMD_inv.E:SetPoint("LEFT",fujiF.botF_R.jinzuCMD_inv.Text,"RIGHT",6,0);
	fujiF.botF_R.jinzuCMD_inv.E:SetFontObject(ChatFontNormal);
	fujiF.botF_R.jinzuCMD_inv.E:SetMaxLetters(6)
	fujiF.botF_R.jinzuCMD_inv.E:SetAutoFocus(false);
	fujiF.botF_R.jinzuCMD_inv.E:SetTextColor(0.7, 0.7, 0.7, 1);
	fujiF.botF_R.jinzuCMD_inv.E:SetScript("OnEditFocusGained", function(self) 
		self:SetTextColor(1, 1, 1, 1);
	end);
	fujiF.botF_R.jinzuCMD_inv.E:SetScript("OnEditFocusLost", function(self)
		self:SetTextColor(0.7, 0.7, 0.7, 1);
		self:SetText(PIGA["Tardis"]["Yell"]["jinzuCMD"])
	end);
	fujiF.botF_R.jinzuCMD_inv.E:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus()
	end);
	fujiF.botF_R.jinzuCMD_inv.E:SetScript("OnEnterPressed", function(self) 
		PIGA["Tardis"]["Yell"]["jinzuCMD"]=self:GetText();
		self:ClearFocus()
		fujiF.Updata_Macro()
	end);
	function fujiF.XZ_zhiye_AutoHuifu(laiyuan)
		fujiF.topF.zhiyeXZ:Hide()
		fujiF.topF.autoHF:Hide()
		fujiF.botF_R.XZ_playerNum.E:Enable()
		if laiyuan=="XZ_zhiye" then
			if PIGA["Tardis"]["Yell"]["XZ_zhiye"] then
				PIGA["Tardis"]["Yell"]["AutoHuifu"]=false;
				fujiF.botF_R.AutoHuifu:SetChecked(false)
			end
		elseif laiyuan=="AutoHuifu" then
			if PIGA["Tardis"]["Yell"]["AutoHuifu"] then
				PIGA["Tardis"]["Yell"]["XZ_zhiye"]=false;
				fujiF.botF_R.XZ_zhiye:SetChecked(false)
			end
		end
		if PIGA["Tardis"]["Yell"]["XZ_zhiye"] then
			fujiF.topF.zhiyeXZ.GetRaidMubiao()
			fujiF.topF.zhiyeXZ.GetRaidPlayers()
			fujiF.topF.zhiyeXZ:Show()
			fujiF.botF_R.XZ_playerNum.E:Disable()
		elseif PIGA["Tardis"]["Yell"]["AutoHuifu"] then
			fujiF.topF.autoHF:Show()
		end
	end
	---职业职责限制
	fujiF.botF_R.XZ_zhiye = PIGCheckbutton(fujiF.botF_R,{"TOPLEFT",fujiF.botF_R.XZ_playerNum,"BOTTOMLEFT",0,-10},{"根据职业职责邀请(自动询问)","当启用职业职责判断，插件会自动询问职业职责，根据上面设置人数邀请，达到设置值将停止邀请"})
	fujiF.botF_R.XZ_zhiye:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Tardis"]["Yell"]["XZ_zhiye"]=true;
		else
			PIGA["Tardis"]["Yell"]["XZ_zhiye"]=false;
		end
		fujiF.XZ_zhiye_AutoHuifu("XZ_zhiye")
	end);
	---职业职责限制
	fujiF.botF_R.AutoHuifu = PIGCheckbutton(fujiF.botF_R,{"TOPLEFT",fujiF.botF_R.XZ_zhiye,"BOTTOMLEFT",0,-10},{"自定义回复/邀请条件","根据自定义触发词组和自动回复或邀请"})
	fujiF.botF_R.AutoHuifu:SetScript("OnClick", function (self)
		if self:GetChecked() then
			PIGA["Tardis"]["Yell"]["AutoHuifu"]=true;
		else
			PIGA["Tardis"]["Yell"]["AutoHuifu"]=false;
		end
		fujiF.XZ_zhiye_AutoHuifu("AutoHuifu")
	end);
	----自动邀请
	fujiF.botF_R.AutoYaoqing = PIGButton(fujiF.botF_R,{"BOTTOMLEFT",fujiF.botF_R,"BOTTOMLEFT",10,6},{100,24},"自动邀请");  
	fujiF.botF_R.AutoYaoqing.Text:SetPoint("CENTER",fujiF.botF_R.AutoYaoqing,"CENTER",8,0);
	fujiF.botF_R.AutoYaoqing.Text:SetTextColor(0, 1, 1, 1);
	fujiF.botF_R.AutoYaoqing.Tex = fujiF.botF_R.AutoYaoqing:CreateTexture(nil, "BORDER");
	fujiF.botF_R.AutoYaoqing.Tex:SetTexture("interface/common/indicator-gray.blp");
	fujiF.botF_R.AutoYaoqing.Tex:SetPoint("RIGHT",fujiF.botF_R.AutoYaoqing.Text,"LEFT",0,-1);
	fujiF.botF_R.AutoYaoqing.Tex:SetSize(23,23);
	fujiF.botF_R.AutoYaoqing:HookScript("OnMouseDown", function(self)
		if self:IsEnabled() then
			self.Text:SetPoint("CENTER",fujiF.botF_R.AutoYaoqing,"CENTER",9.5,-1.5);
		end
	end);
	fujiF.botF_R.AutoYaoqing:HookScript("OnMouseUp", function(self)
		if self:IsEnabled() then
			self.Text:SetPoint("CENTER",fujiF.botF_R.AutoYaoqing,"CENTER",8,0);
		end
	end);
	fujiF.botF_R.AutoYaoqing:SetScript("OnClick", function (self)
		fujiF.zidongyaoqingFun()
	end)
	--当前人数
	fujiF.botF_R.DQ_playerNum = PIGFontString(fujiF.botF_R,{"LEFT",fujiF.botF_R.AutoYaoqing,"RIGHT",4,0},"当前人数:");
	fujiF.botF_R.DQ_playerNum:SetTextColor(0, 1, 0, 1)
	fujiF.botF_R.DQ_playerNumV = PIGFontString(fujiF.botF_R,{"LEFT", fujiF.botF_R.DQ_playerNum, "RIGHT", 4,0},"0");
	fujiF.botF_R.DQ_playerNumV:SetTextColor(1, 1, 0, 1)
	fujiF.botF_R.DQ_playerNumxie = PIGFontString(fujiF.botF_R,{"LEFT", fujiF.botF_R.DQ_playerNumV, "RIGHT", 2,0},"/");
	fujiF.botF_R.DQ_playerNumV_max = PIGFontString(fujiF.botF_R,{"LEFT", fujiF.botF_R.DQ_playerNumxie, "RIGHT", 2,0},"0");
	fujiF.botF_R.DQ_playerNumV_max:SetTextColor(1, 0, 0, 1)
	--根据指令邀请
	fujiF.botF_R.ShowDesktopBut = PIGCheckbutton(fujiF.botF_R,{"LEFT",fujiF.botF_R.AutoYaoqing,"RIGHT",120,0},{"显示桌面图标","在游戏主界面显示快捷喊话图标\n在你打开《自动邀请》的状态下会忽略此选项常驻显示"})
	fujiF.botF_R.ShowDesktopBut:SetScript("OnClick", function (self)
		if self:GetChecked() then
			pig_YELL:Show()
			PIGA["Tardis"]["Yell"]["ShowDesktopBut"]=true;
		else
			pig_YELL:Hide()
			PIGA["Tardis"]["Yell"]["ShowDesktopBut"]=false;
		end
	end);
	--判断人数
	local function OFF_autoInvite(msg)
		Pig_OptionsUI.autoInvite_shikong=false;
		fujiF.botF_R.AutoYaoqing.Tex:SetTexture("interface/common/indicator-gray.blp");
		pig_YELL.AutoYaoqing.Tex:SetTexture("interface/common/indicator-gray.blp");
		fujiF.botF_R.hanhuaOpen.Tex:SetTexture("interface/common/indicator-gray.blp");
		fujiF:UnregisterEvent("CHAT_MSG_WHISPER");
		fujiF:UnregisterEvent("CHAT_MSG_SYSTEM");
		PIGinfotip:TryDisplayMessage(msg);
		if not PIGA["Tardis"]["Yell"]["ShowDesktopBut"] then pig_YELL:Hide() end
	end
	function fujiF.GetPlayerNumOK(laiyuan)
		local numGroupMembers = GetNumGroupMembers("LE_PARTY_CATEGORY_HOME")
		fujiF.botF_R.DQ_playerNumV:SetText(numGroupMembers)
		if numGroupMembers>=PIGA["Tardis"]["Yell"]["XZ_playerNumV"] then
			if laiyuan~="event" then
				OFF_autoInvite("已达目标人数,自动邀请已关闭")
			end
			return false
		else
			return numGroupMembers
		end
		return true
	end
	--判断是否是队长/团长/助理
	function fujiF.NO_tuanzhang_zhuli(laiyuan)
		if IsInGroup() then
			local isLeader = UnitIsGroupLeader("player", "LE_PARTY_CATEGORY_HOME");
			local isTrue = UnitIsGroupAssistant("player", "LE_PARTY_CATEGORY_HOME");
			if not isLeader and not isTrue then
				if laiyuan~="event" then
					OFF_autoInvite("你不是队长/团长/助理,自动邀请已关闭")
				end
				return false
			end
		end
		return true
	end
	function fujiF.zidongyaoqingFun()
		if Pig_OptionsUI.autoInvite_daiben then
			PIGinfotip:TryDisplayMessage("带本助手自动邀请处于开启状态，请先关闭");
		else
			if Pig_OptionsUI.autoInvite_shikong then
				OFF_autoInvite("已关闭自动邀请")
			else
				if fujiF.NO_tuanzhang_zhuli() and fujiF.GetPlayerNumOK() then
					Pig_OptionsUI.autoInvite_shikong=true
					fujiF.botF_R.AutoYaoqing.Tex:SetTexture("interface/common/indicator-green.blp");
					pig_YELL.AutoYaoqing.Tex:SetTexture("interface/common/indicator-green.blp");
					fujiF:RegisterEvent("CHAT_MSG_WHISPER");
					fujiF:RegisterEvent("CHAT_MSG_SYSTEM")
					fujiF.Updata_Macro("OPEN")
					PIGinfotip:TryDisplayMessage("已开启自动邀请");
					pig_YELL:Show()
				end
			end
		end
	end
	--主屏幕快捷按钮===
	pig_YELL:PIGSetBackdrop(0.2)
	pig_YELL.AutoYaoqing = CreateFrame("Button",nil,pig_YELL);
	pig_YELL.AutoYaoqing:SetPoint("LEFT",pig_YELL,"LEFT",2,0);
	pig_YELL.AutoYaoqing:SetSize(WWHH,WWHH);
	pig_YELL.AutoYaoqing.Tex = pig_YELL.AutoYaoqing:CreateTexture(nil, "BORDER");
	pig_YELL.AutoYaoqing.Tex:SetTexture("interface/common/indicator-gray.blp");
	pig_YELL.AutoYaoqing.Tex:SetPoint("CENTER",0,-1);
	pig_YELL.AutoYaoqing.Tex:SetSize(WWHH,WWHH);
	PIGEnter(pig_YELL.AutoYaoqing,"开启/关闭自动邀请\n按住可拖动位置")
	pig_YELL.AutoYaoqing:SetScript("OnClick", function (self)
		PlaySound(SOUNDKIT.IG_CHAT_EMOTE_BUTTON);
		fujiF.zidongyaoqingFun()
	end)
	pig_YELL.AutoYaoqing:RegisterForDrag("LeftButton")
	pig_YELL.AutoYaoqing:HookScript("OnDragStart",function(self)
		pig_YELL:StartMoving()
	end)
	pig_YELL.AutoYaoqing:HookScript("OnDragStop",function(self)
		pig_YELL:StopMovingOrSizing()
	end)
	pig_YELL.yellbut = PIGButton(pig_YELL,{"LEFT",pig_YELL.AutoYaoqing,"RIGHT",2,0},{70,WWHH-6},"喊话");  
	pig_YELL.yellbut:SetScript("OnClick", function (self)
		fujiF.Kaishi_Yell()
	end)
	--------
	local function hanhuadaojishiTime()
		if fujiF.hanhuadaojishi>0 then
			fujiF.botF_L.Yell_NR.yellbut:SetText("喊话("..fujiF.hanhuadaojishi..")");
			pig_YELL.yellbut:SetText("喊话("..fujiF.hanhuadaojishi..")");
			C_Timer.After(1,hanhuadaojishiTime)
			fujiF.hanhuadaojishi=fujiF.hanhuadaojishi-1
		else
			fujiF.botF_L.Yell_NR.yellbut:Enable() 
			fujiF.botF_L.Yell_NR.yellbut:SetText("喊话");
			pig_YELL.yellbut:Enable();
			pig_YELL.yellbut:SetText("喊话");
		end
	end
	function fujiF.Kaishi_Yell()
		local PindaoList=fujiF.PindaoList
		local yellpindaolist = {}
		for i=1,#PindaoList do
			if PIGA["Tardis"]["Yell"]["Yell_CHANNEL"][PindaoList[i][1]] then
				table.insert(yellpindaolist,{PindaoList[i][2],PindaoList[i][3]})
			end
		end
		local keyongshu = #yellpindaolist
		if keyongshu>0 then
			local famsg =Get_famsg()
			for x=1,#yellpindaolist do
				local suijishu=random(1, 8)
				local famsg = famsg..suijizifu[suijishu]
				if yellpindaolist[x][1]=="CHANNEL" then
					SendChatMessage(famsg,yellpindaolist[x][1],nil,yellpindaolist[x][2])
				else
					SendChatMessage(famsg,yellpindaolist[x][1])
				end
			end
			fujiF.hanhuadaojishi=fujiF.hanhuajiange*keyongshu
			fujiF.botF_L.Yell_NR.yellbut:Disable();
			fujiF.botF_L.Yell_NR.yellbut:SetText("喊话("..fujiF.hanhuadaojishi..")");
			pig_YELL.yellbut:Disable();
			pig_YELL.yellbut:SetText("喊话("..fujiF.hanhuadaojishi..")");
			hanhuadaojishiTime()
		end
	end
	pig_YELL.setbut = CreateFrame("Button",nil,pig_YELL, "TruncatedButtonTemplate"); 
	pig_YELL.setbut:SetNormalTexture("interface/gossipframe/healergossipicon.blp"); 
	pig_YELL.setbut:SetHighlightTexture(130718);
	pig_YELL.setbut:SetSize(WWHH-6,WWHH-6);
	pig_YELL.setbut:SetPoint("LEFT",pig_YELL.yellbut,"RIGHT",5,0);
	pig_YELL.setbut.Down = pig_YELL.setbut:CreateTexture(nil, "OVERLAY");
	pig_YELL.setbut.Down:SetTexture(130839);
	pig_YELL.setbut.Down:SetSize(WWHH-6,WWHH-6);
	pig_YELL.setbut.Down:SetPoint("CENTER");
	pig_YELL.setbut.Down:Hide();
	pig_YELL.setbut:SetScript("OnMouseDown", function (self)
		self.Down:Show();
	end);
	pig_YELL.setbut:SetScript("OnMouseUp", function (self)
		self.Down:Hide()
	end);
	pig_YELL.setbut:HookScript("OnClick", function (self)
		if InvF:IsShown() then
			InvF:Hide()
		else
			InvF:Show()
			Create.Show_TabBut_R(InvF.F,fujiF,fujiTabBut)
		end
	end);

	--过滤频道发言过频提示
	local function guolvliaotiancuowuINFO(self,event,arg1,...)
		if arg1=="THROTTLED" then
			return true;
		else
	    	return false, arg1, ...
		end
	end
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE",guolvliaotiancuowuINFO)
	local function hanhuaMSGinfo()
		local PindaoList=fujiF.PindaoList
		local yellpindaolist = {}
		for i=1,#PindaoList do
			if PIGA["Tardis"]["Yell"]["Yell_CHANNEL"][PindaoList[i][1]] then
				if PindaoList[i][2]~="GUILD" and PindaoList[i][2]~="SAY" and PindaoList[i][2]~="YELL" then
					table.insert(yellpindaolist,{PindaoList[i][2],PindaoList[i][3]})
				end
			end
		end
		local keyongshu = #yellpindaolist
		if keyongshu>0 then
			local famsg =Get_famsg()
			for x=1,#yellpindaolist do
				local suijishu=random(1, 8)
				local famsg = famsg..suijizifu[suijishu]
				if yellpindaolist[x][1]=="CHANNEL" then
					SendChatMessage(famsg,yellpindaolist[x][1],nil,yellpindaolist[x][2])
				else
					SendChatMessage(famsg,yellpindaolist[x][1])
				end
			end
		end
	end
	function fujiF.hanhuaOpen()
		if fujiF.NO_tuanzhang_zhuli() and fujiF.GetPlayerNumOK() then
			C_Timer.After(0.1,hanhuaMSGinfo)
			C_Timer.After(0.2,hanhuaMSGinfo)
			C_Timer.After(0.3,hanhuaMSGinfo)
			C_Timer.After(0.4,hanhuaMSGinfo)
			C_Timer.After(0.5,hanhuaMSGinfo)
			C_Timer.After(0.6,hanhuaMSGinfo)
			C_Timer.After(0.7,hanhuaMSGinfo)
			C_Timer.After(0.8,hanhuaMSGinfo)
			C_Timer.After(0.9,hanhuaMSGinfo)
			C_Timer.After(1.0,hanhuaMSGinfo)
			C_Timer.After(1.1,hanhuaMSGinfo)
			C_Timer.After(PIGA["Tardis"]["Yell"]["Yell_CD"],fujiF.hanhuaOpen)
		end
	end

	---
	fujiF.botF_R.hanhuaOpen = PIGButton(fujiF.botF_R,{"TOPLEFT",fujiF.botF_R,"BOTTOMLEFT",10,-6},{100,24},"自动喊话");  
	fujiF.botF_R.hanhuaOpen.Text:SetPoint("CENTER",fujiF.botF_R.hanhuaOpen,"CENTER",8,0);
	fujiF.botF_R.hanhuaOpen.Text:SetTextColor(0, 1, 1, 1);
	fujiF.botF_R.hanhuaOpen.Tex = fujiF.botF_R.hanhuaOpen:CreateTexture(nil, "BORDER");
	fujiF.botF_R.hanhuaOpen.Tex:SetTexture("interface/common/indicator-gray.blp");
	fujiF.botF_R.hanhuaOpen.Tex:SetPoint("RIGHT",fujiF.botF_R.hanhuaOpen.Text,"LEFT",0,-1);
	fujiF.botF_R.hanhuaOpen.Tex:SetSize(23,23);
	fujiF.botF_R.hanhuaOpen:HookScript("OnMouseDown", function(self)
		if self:IsEnabled() then
			self.Text:SetPoint("CENTER",fujiF.botF_R.hanhuaOpen,"CENTER",9.5,-1.5);
		end
	end);
	fujiF.botF_R.hanhuaOpen:HookScript("OnMouseUp", function(self)
		if self:IsEnabled() then
			self.Text:SetPoint("CENTER",fujiF.botF_R.hanhuaOpen,"CENTER",8,0);
		end
	end);
	fujiF.botF_R.hanhuaOpen:SetScript("OnClick", function (self)
		if Pig_OptionsUI.autoInvite_shikong then
			OFF_autoInvite("已关闭自动喊话")
		else
			Pig_OptionsUI.autoInvite_shikong=true
			fujiF.botF_R.AutoYaoqing.Tex:SetTexture("interface/common/indicator-green.blp");
			pig_YELL.AutoYaoqing.Tex:SetTexture("interface/common/indicator-green.blp");
			fujiF.botF_R.hanhuaOpen.Tex:SetTexture("interface/common/indicator-green.blp");
			fujiF:RegisterEvent("CHAT_MSG_WHISPER");
			fujiF:RegisterEvent("CHAT_MSG_SYSTEM")
			fujiF.Updata_Macro("OPEN")
			PIGinfotip:TryDisplayMessage("已开启自动喊话");
			pig_YELL:Show()
			hanhuaMSGinfo()
			C_Timer.After(PIGA["Tardis"]["Yell"]["Yell_CD"],fujiF.hanhuaOpen)
		end
	end)
	fujiF.botF_R.hanhuaOpen:Hide()
	---间隔
	fujiF.botF_R.hanhuaOpen.E = CreateFrame("EditBox", nil, fujiF.botF_R.hanhuaOpen,"InputBoxInstructionsTemplate");
	fujiF.botF_R.hanhuaOpen.E:SetSize(50,26);
	fujiF.botF_R.hanhuaOpen.E:SetPoint("LEFT",fujiF.botF_R.hanhuaOpen,"RIGHT",70,0);
	fujiF.botF_R.hanhuaOpen.E:SetFontObject(ChatFontNormal);
	fujiF.botF_R.hanhuaOpen.E:SetMaxLetters(4)
	fujiF.botF_R.hanhuaOpen.E:SetAutoFocus(false);
	fujiF.botF_R.hanhuaOpen.E:SetNumeric(true)
	fujiF.botF_R.hanhuaOpen.E:SetTextColor(0.7, 0.7, 0.7, 1);
	fujiF.botF_R.hanhuaOpen.E:SetScript("OnEditFocusGained", function(self) 
		self:SetTextColor(1, 1, 1, 1);
	end);
	fujiF.botF_R.hanhuaOpen.E:SetScript("OnEditFocusLost", function(self)
		self:SetTextColor(0.7, 0.7, 0.7, 1);
		self:SetText(PIGA["Tardis"]["Yell"]["Yell_CD"])
	end);
	fujiF.botF_R.hanhuaOpen.E:SetScript("OnEscapePressed", function(self) 
		self:ClearFocus()
	end);
	fujiF.botF_R.hanhuaOpen.E:SetScript("OnEnterPressed", function(self) 
		if self:GetNumber()<30 then
			self:SetText(300)
			PIGA["Tardis"]["Yell"]["Yell_CD"]=self:GetNumber();
			PIGinfotip:TryDisplayMessage("不能小于300秒");
		else
			PIGA["Tardis"]["Yell"]["Yell_CD"]=self:GetNumber();
		end
		self:ClearFocus()
	end);
	fujiF.botF_R.hanhuaOpen.E.biaoti = PIGFontString(fujiF.botF_R.hanhuaOpen.E,{"RIGHT",fujiF.botF_R.hanhuaOpen.E,"LEFT",-5,0},"\124cff00FF00间隔/S：\124r","OUTLINE");

	--===
	fujiF.botF_R:HookScript("OnShow", function(self)
		self.XZ_playerNum:SetChecked(PIGA["Tardis"]["Yell"]["XZ_playerNum"])
		self.XZ_playerNum.E:SetText(PIGA["Tardis"]["Yell"]["XZ_playerNumV"])
		self.DQ_playerNumV_max:SetText(PIGA["Tardis"]["Yell"]["XZ_playerNumV"])
		self.jinzuCMD_inv:SetChecked(PIGA["Tardis"]["Yell"]["jinzuCMD_inv"])
		self.jinzuCMD_inv.E:SetText(PIGA["Tardis"]["Yell"]["jinzuCMD"]);
		self.XZ_zhiye:SetChecked(PIGA["Tardis"]["Yell"]["XZ_zhiye"])
		self.AutoHuifu:SetChecked(PIGA["Tardis"]["Yell"]["AutoHuifu"])
		self.DQ_playerNumV:SetText(GetNumGroupMembers("LE_PARTY_CATEGORY_HOME"))
		self.ShowDesktopBut:SetChecked(PIGA["Tardis"]["Yell"]["ShowDesktopBut"])
		fujiF.botF_R.hanhuaOpen.E:SetText(PIGA["Tardis"]["Yell"]["Yell_CD"])
	end);
	--===================================
	local yizuduiERR=ERR_ALREADY_IN_GROUP_S:gsub("%%s","")
	--local zhiyeweizhiNameQ={"坦克","治疗","输出"}
	--local zhiyeweizhiKey={{"坦克","熊D","熊T","T","MT","坦","战士T","防骑","FQ"},{"治疗","奶","大奶"},{"输出","狂暴战","KBZ", "kbz", "狂暴", "DPS", "dps","惩戒"}}
	local zhiyeweizhiKey={{"T","坦","熊","防骑","FQ"},{"N","奶","治疗"},{"DPS", "dps","伤害","输出","KBZ", "kbz", "狂暴","惩戒","电萨","鸟德","鸟D"}}
	--执行邀请
	local function zhixingINVfun(arg5)
		if PIGA["Tardis"]["Yell"]["XZ_playerNum"] then
			local renshu = fujiF.GetPlayerNumOK()
			if renshu then
				if renshu==5 and not IsInRaid("LE_PARTY_CATEGORY_HOME") then
					ConvertToRaid() 
				end
				InviteUnit(arg5)
			end
		else
			InviteUnit(arg5)
		end
	end
	local function PIG_GROUP_UPDATE()
		fujiF.NO_tuanzhang_zhuli("event")
		fujiF.GetPlayerNumOK("event")
		if PIGA["Tardis"]["Yell"]["XZ_zhiye"] then
			fujiF.topF.zhiyeXZ.GetRaidPlayers()
		end
	end
	fujiF.lishiwanjiaxinxi={};
	function fujiF.panduan_miyuguo(arg5)
		for i=1,#fujiF.lishiwanjiaxinxi do
			if arg5 == fujiF.lishiwanjiaxinxi[i][2] then
				return true
			end
		end
		return false
	end
	function fujiF.GetKeyXulieID(arg1)					
		for Keyxulie=1,#zhiyeweizhiKey do
			for Keytxt=1,#zhiyeweizhiKey[Keyxulie] do
				if arg1:match(zhiyeweizhiKey[Keyxulie][Keytxt]) then
					return Keyxulie
				end
			end
		end
		return false
	end
	----------
	fujiF:RegisterEvent("PLAYER_ENTERING_WORLD")
	fujiF:RegisterEvent("GROUP_ROSTER_UPDATE")
	fujiF:HookScript("OnEvent",function(self,event,arg1,_,_,_,arg5,_,_,_,_,_,_,arg12)
		--print(event)
		if event=="PLAYER_ENTERING_WORLD" then
			fujiF.XZ_zhiye_AutoHuifu()
		end
		if event=="GROUP_ROSTER_UPDATE" then
			C_Timer.After(0.6,PIG_GROUP_UPDATE)
		end
		if event=="CHAT_MSG_SYSTEM" then
			if arg1:match(yizuduiERR) then
				local wanjianameXXk=arg1:gsub(yizuduiERR,"")
				SendChatMessage("[!Pig] 你已有队伍，请退组后再M", "WHISPER", nil, wanjianameXXk);
			end
		end
		if event=="CHAT_MSG_WHISPER" then
			for ih=1,#fujiF.lishiwanjiaxinxi do
				if (GetServerTime()-fujiF.lishiwanjiaxinxi[ih][1])>60 then
					table.remove(fujiF.lishiwanjiaxinxi, ih);
				end
			end
			if arg1:match("[!Pig]") then return end
			local localizedClass, englishClass= GetPlayerInfoByGUID(arg12)
			if Pig_OptionsUI.autoInvite_shikong then
				if arg1==PIGA["Tardis"]["Yell"]["jinzuCMD"] then
					if PIGA["Tardis"]["Yell"]["XZ_zhiye"] then--判断职业职责
						local zhizeNum = #cl_Name_Role[englishClass]
						if zhizeNum==1 then
							local xulieID = RolesXulie[cl_Name_Role[englishClass][1]]
							local zhizezhiyeList = Roles_List[xulieID]
							for id=1,#zhizezhiyeList do
								if zhizezhiyeList[id][1]==englishClass then
									if fujiF.Datas_DQ.Xulie_MB[xulieID][id]<fujiF.Datas_MB.Xulie_MB[xulieID][id] then
										zhixingINVfun(arg5)
									else
										SendChatMessage("[!Pig] "..localizedClass .. "已满，可换其他职业，感谢支持", "WHISPER", nil, arg5);
									end
									break
								end	
							end
						elseif zhizeNum>1 then
							local xuqiuzhizeInfo = {}
							local xulieIDList = cl_Name_Role[englishClass]
							for xu=1,#xulieIDList do
								local xulieID = RolesXulie[xulieIDList[xu]]
								xuqiuzhizeInfo[xulieIDList[xu]]=0
								local zhizezhiyeList = Roles_List[xulieID]
								for id=1,#zhizezhiyeList do
									if zhizezhiyeList[id][1]==englishClass then
										if fujiF.Datas_DQ.Xulie_MB[xulieID][id]<fujiF.Datas_MB.Xulie_MB[xulieID][id] then
											table.insert(xuqiuzhizeInfo,xulieIDList[xu])
										end
									end	
								end
							end
							if #xuqiuzhizeInfo>0 then
								local zuduizhushou_MSG=localizedClass.."尚缺:";
								for img=1,#xuqiuzhizeInfo do
									zuduizhushou_MSG=zuduizhushou_MSG.._G[xuqiuzhizeInfo[img]]..","
								end
								SendChatMessage("[!Pig] "..zuduizhushou_MSG.."请回复职责", "WHISPER", nil, arg5);
								table.insert(fujiF.lishiwanjiaxinxi,{GetServerTime(),arg5,chazhiyefenlai})
							end
						end
					elseif PIGA["Tardis"]["Yell"]["XZ_zhiye"] then--根据自定义内容判断

					else
						zhixingINVfun(arg5)
					end
				else
					if PIGA["Tardis"]["Yell"]["XZ_zhiye"] then
						if fujiF.panduan_miyuguo(arg5) then
							local Keyxulie = fujiF.GetKeyXulieID(arg1)
							if Keyxulie then
								local xulieID = Keyxulie
								local zhizezhiyeList = Roles_List[xulieID]
								for id=1,#zhizezhiyeList do
									if zhizezhiyeList[id][1]==englishClass then
										if fujiF.Datas_DQ.Xulie_MB[xulieID][id]<fujiF.Datas_MB.Xulie_MB[xulieID][id] then
											zhixingINVfun(arg5)
										else
											SendChatMessage("[!Pig] ".._G[Roles[Keyxulie]]..localizedClass .. "已满，可换其他职业或天赋，感谢支持", "WHISPER", nil, arg5);
										end
										break
									end	
								end
							end
						end
					end
				end
			end
		end
	end)
end